/* Modulo router

Segun el hash,

 */
define([
  'jquery',
  'underscore',
  'backbone',
  'pageslider',
  'vars',
  'modal',
  'text!tpl/ConstruccionView.html',
  'appview',
  'polyglot'
], function($, _, Backbone, ps, vars, modal, ConstruccionView, appView, polyglotinstance){
 
	var AppRouter = Backbone.Router.extend({
		routes: {
		  'ciudad/:id': 'ciudad',
		  'ciudad/:id/quenecesitas': 'quenecesitas',
		  'ciudad/:id/categoria/:id': 'categoria',
		  'ficha/:id': 'ficha',
		  'mapa/:id': 'mapa',
		  'ciudad/:id/ofertaspromociones': 'ofertaspromociones',
		  /*'ciudad/:id/ofertaspromocionesmasvistas': 'ofertaspromocionesmasvistas',
		  'ciudad/:id/ofertaspromocionesporsector': 'ofertaspromocionesporsector',*/
		  'ciudad/:id/categoria-promociones/:id': 'categoriapromociones',
		  'ficha-promocion/:id': 'ficha-promocion',
		  'ciudad/:id/quevisitar': 'quevisitar',
		  'ciudad/:id/quevisitar/:id': 'quevisitarcategoria',
		  'ficha-quevisitar/:id': 'quevisitarficha',
		  'mapa-turismo/:id': 'turismomapa',
		  'mapa-grupo': 'mapagrupo',
		  'ciudad/:id/yademas': 'yademas',
		  'info': 'info',
		  'info/:seccion': 'info',
		  'infoficha/:view': 'infoficha',
		  'cuenta/misdatos': 'misdatos',
		  'cuenta/misplanes': 'misplanes',
		  'cuenta/misplanes/comercios': 'misplanes_comercios',
		  'cuenta/misplanes/promociones': 'misplanes_promociones',
		  'cuenta/misplanes/eventos': 'misplanes_eventos',
		  'cuenta/misplanes/turismo': 'misplanes_turismo',
		  'cuenta/misfavoritos': 'misfavoritos',
		  'cuenta/salircuenta': 'salircuenta',
		  'buscar': 'buscar',
		  'login': 'login',
		  'login/:seccion': 'login',
		  'miespacio': 'miespacio',
		  'micuenta': 'micuenta',
		  'cambiaridioma': 'cambiaridioma',
		  'camara': 'camara',
		  'ciudad/:id/planes': 'planes',
		  'ciudad/:id/planes/tiendas': 'planesTiendas',
		  'ciudad/:id/planes/ofertas': 'planesOfertas',
		  'ciudad/:id/planes/lugares': 'planesLugares',
		  'ciudad/:id/planes/eventos': 'planesEventos',
		  'ciudad/:id/eventos/:fecha': 'eventosListado',
		  'ciudad/:id/eventos': 'eventos',
		  'ficha-evento/:id': 'fichaEventos',
		  'ciudad/:id/noticias': 'noticias',
		  'listado-noticias/:rss': 'listadoNoticias',
		  'ficha-noticia/:id': 'fichaNoticia',
		  'ficha-radio/:url': 'fichaRadio',
		  'ciudad/:id/radio': 'radio',
		  'ciudad/:id/cine': 'cine',
		  'listado-cine/:rss': 'listadoCine',
		  'ficha-cine/:id': 'fichaCine',
		  'ciudad/:id/tapas': 'tapas',
		  'ciudad/:id/empiezatapear': 'empiezatapear',
		  'ficha-tapa/:id': 'fichaTapa',
		  'ciudad/:id/farmacia-de-guardia': 'farmaciaDeGuardia',
		  'ciudad/:id/baresyrestaurantes': 'baresYRestaurantes',
		  'ciudad/:id/telefonos-de-interes': 'telefonosDeInteres',
		  // Default
		  '': 'defaultAction'
		}
	  });

  var initialize = function(){

	
	// Clase router
    var app_router = new AppRouter;
	
	// Select cambiar idioma
	$(document).on("click","a.cambiar_idioma",function(e){
		e.preventDefault();
		polyglot.clear();
		language = $(this).attr("data-idioma");

		require(['text!../lang/'+language+'.js'],function(idioma){
			json = JSON.parse(idioma);
			polyglot.extend(json);
		});
		
		localStorage.setItem("language",language);
		vars.goback();
	});

	// Cargamos lenguage solicitado	
	require(['text!../lang/'+language+'.js'],function(idioma){
		json = JSON.parse(idioma);
		polyglot.extend(json);
	});

		// Llamamos a inicio de login
		vars.initLogin();
	
	// Inicializamos modal
	modal.initialize();
	// Marca para saber si la pestaña promociones está abierta
	
	
    app_router.on('route:defaultAction', function(actions){
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){

				var plantilla = new ListadoView({css:"ciudades", noback:true, titulo:'<span class="icono icon-cayetano"></span>Sr. Cayetano', url:"ciudades", link : "#ciudad/", colaboradores : 1});
				appView.showView(plantilla);
				//AppSlider.slidePage(plantilla.render().$el);
				delete vars.planesCache;
				delete vars.homeCache;
				delete vars.noticiasCache;
            }
        );

		
		
		
		
		$("footer").hide();
    });
	
	
    app_router.on('route:quenecesitas', function(ciudadId){
		$("footer").show();
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({css:"iconos", titulo:"Tiendas y restaurantes", url:"ciudad/" + ciudadId + "/empresastipo", link : "#ciudad/"+ciudadId+"/categoria/"});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );

		
    });
	
    app_router.on('route:categoria', function(ciudadId, categoriaId){
		$("footer").show();
		
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){

				var plantilla = new ListadoView({titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/categoria/" + categoriaId, link : "#ficha/"});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );

		
		
		
    });
	
    app_router.on('route:ficha', function(fichaId){
		$("footer").show();
		
        require(
            ['views/FichaView'],
            function(FichaView){
				$("footer").show();
				var plantilla = new FichaView({titulo: vars.getTituloActual() ,url: 'empresa/' + fichaId});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
				//touchscroll.reload();
            }
        );
		
		
    });


    app_router.on('route:ciudad', function(ciudadId){
		vars.ciudad = ciudadId;
		localStorage.setItem("ciudad",ciudadId);

		if (localStorage.getItem("ciudades_cache") != null){
			aux = JSON.parse(localStorage.getItem("ciudades_cache"));

			localStorage.setItem("ciudadnombre",aux[ciudadId]);
			vars.ciudadNombre = aux[ciudadId];
		}
		else{
			vars.ciudadNombre = localStorage.getItem("ciudadnombre");
		}

        require(
            ['views/HomeView'],
            function(HomeView){
				$("footer").show();
				var plantilla = new HomeView({ciudad:ciudadId});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
				//$("div.page-center div.scroller").css('top',((parseInt(self.$("div.carrusel").css("padding-bottom")) + 46) + "px"));
				delete(vars.cacheeventoscategoria);
				
				//touchscroll.reload();
            }
        );



		
    });

    app_router.on('route:planes', function(ciudadId){

        require(
            ['views/PlanesView'],
            function(PlanesView){
				$("footer").show();
				var plantilla = new PlanesView({ciudad:ciudadId});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );

		
    });

    app_router.on('route:planesTiendas', function(ciudadId){
		$("footer").show();
		
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){

				var plantilla = new ListadoView({titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/planes/tiendas", link : "#ficha/",cache: false});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);

            }
        );


    });
	
    app_router.on('route:planesOfertas', function(ciudadId){
		$("footer").show();
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({css:"promociones", titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/planes/ofertas", link : "#ficha-promocion/"});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
		
		
		
		

    });
	
    app_router.on('route:planesLugares', function(ciudadId){
		$("footer").show();
		
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/planes/lugares", link : "#ficha-quevisitar/",cache: false});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );


    });
	
	
    app_router.on('route:planesEventos', function(ciudadId){
		$("footer").show();
		
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/planes/eventos", link : "#ficha-evento/"});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );


    });
	
	
	
	
    app_router.on('route:eventos', function(){
        require(
            ['views/EventosView'],
            function(EventosView){
				$("footer").hide();
				
				var plantilla = new EventosView();
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
				//delete(vars.cacheeventoscategoria);
				
            }
        );

		
		
    });
    app_router.on('route:eventosListado', function(ciudad,fecha){
        require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				$("footer").hide();
				
				var plantilla = new ListadoView({titulo: vars.getTituloActual() ,url:"ciudad/" + vars.ciudad + "/eventos/" + fecha, link : "#ficha-evento/", css: "eventos"});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );

		
		
    });
	
    app_router.on('route:fichaEventos', function(fichaId){
		$("footer").show();
		
		require(
            ['views/FichaEventosView'],
            function(FichaEventosView){
				var plantilla = new FichaEventosView({titulo: vars.getTituloActual() ,url: 'evento/' + fichaId});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );


		
		
    });

	
    app_router.on('route:noticias', function(){
        require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				$("footer").show();
				vars.noticiasCache = Array();
				var plantilla = new ListadoView({titulo: vars.getTituloActual(), url:"ciudad/" + vars.ciudad + "/noticias", link : "#listado-noticias/", css: "eventos"});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
    });
	
    app_router.on('route:listadoNoticias', function(rss){
        require(
            ['views/NoticiasView'],
            function(NoticiasView){
				$("footer").show();

				var plantilla = new NoticiasView({titulo: vars.getTituloActual(), rss: rss});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
    });
	
	
    app_router.on('route:fichaNoticia', function(id){
		
        require(
            ['views/NoticiasFichaView'],
            function(NoticiasFichaView){
				$("footer").show();

				var plantilla = new NoticiasFichaView({titulo: vars.getTituloActual(),id : id});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
    });





    app_router.on('route:fichaRadio', function(url){
		
        require(
            ['views/RadioFichaView'],
            function(RadioFichaView){
				$("footer").show();

				var plantilla = new RadioFichaView({url: url});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
    });
	
	
	
	
	
    app_router.on('route:cine', function(){
        require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				$("footer").show();
				vars.noticiasCache = Array();
				var plantilla = new ListadoView({titulo: vars.getTituloActual(), url:"ciudad/" + vars.ciudad + "/cine", link : "#listado-cine/", css: "eventos"});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
    });
	
    app_router.on('route:listadoCine', function(rss){
        require(
            ['views/NoticiasView'],
            function(NoticiasView){
				$("footer").show();

				var plantilla = new NoticiasView({titulo: vars.getTituloActual(), rss: rss});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
    });
	
	
    app_router.on('route:fichaCine', function(id){
		
        require(
            ['views/NoticiasFichaView'],
            function(NoticiasFichaView){
				$("footer").show();

				var plantilla = new NoticiasFichaView({titulo: vars.getTituloActual(),id : id});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
    });


    app_router.on('route:radio', function(){
		plataforma = device.platform;
		
        require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				$("footer").show();
				if (plataforma == "iOS"){
					var plantilla = new ListadoView({titulo: vars.getTituloActual(), url:"ciudad/" + vars.ciudad + "/radios", link : "", css: "eventos", externo: true});
				}
				else{
					var plantilla = new ListadoView({titulo: vars.getTituloActual(), url:"ciudad/" + vars.ciudad + "/radios", link : "#ficha-radio/", css: "eventos"});
				}
					
				//AppSlider.slidePage( plantilla.render().$el);
				appView.showView(plantilla);
				
            }
        );
    });
	
	
    app_router.on('route:mapa', function(comercioId){
        require(
            ['views/MapView'],
            function(MapView){
				$("footer").hide();
				
				var plantilla = new MapView({url: 'empresa-mapa/' + comercioId});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );

		
		
    });
    app_router.on('route:mapagrupo', function(comercioId){
        require(
            ['views/MapGrupoView'],
            function(MapGrupoView){
				$("footer").hide();
				vars.putSeccion("Mapa");
				
				var plantilla = new MapGrupoView();
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );

		
		
    });
	
	
	
	
	var mostrarLogin = function(seccion){

		if (vars.login["logueado"] == true){
			mostrarCuenta();
		}
		else{
		
			$("footer").hide();
			require(
				['views/LoginView'],
				function(LoginView){				
					var plantilla = new LoginView({seccion:seccion});
					modal.show(plantilla.render().$el);
					//AppSlider.saveHistory();
	
				}
			);

		}
    }
	
    app_router.on('route:login', mostrarLogin);	
	var mostrarCuenta = function(){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			vars.putSeccion("Mi cuenta");
			$("footer").hide();
	
			require(
				['views/InformacionView'],
				function(InformacionView){
					var plantilla = new InformacionView({ciudad:vars.ciudad, seccion: "cuenta"});
					//AppSlider.slidePage(plantilla.render().$el);
					appView.showView(plantilla);
				}
			);
			
			
			
		}
		
    }
	
    app_router.on('route:micuenta', mostrarCuenta);
    app_router.on('route:info', function(seccion){
		
		/*$("footer").hide();
		PromocionesViewElemento = false;

        require(
            ['views/test'],
            function(InformacionView){
				var plantilla = new InformacionView({ciudad:vars.ciudad, seccion: seccion});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
*/
		
		
		
		
		
		$("footer").hide();

        require(
            ['views/InformacionView'],
            function(InformacionView){
				var plantilla = new InformacionView({ciudad:vars.ciudad, seccion: seccion});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
				
            }
        );

    });
	
	
    app_router.on('route:buscar', function(){
			$("footer").hide();
			
			
			require(
				['views/BuscarView'],
				function(BuscarView){				
					var plantilla = new BuscarView();
					//AppSlider.slidePage(plantilla.render().$el);
					appView.showView(plantilla);
				}
			);

		
    });

	
	
    app_router.on('route:infoficha', function(view){
		$("footer").hide();

        require(
            ['views/InformacionFichaView'],
            function(InformacionFichaView){
				$("footer").hide();
				var plantilla = new InformacionFichaView({ciudad:vars.ciudad, view: view});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );

    });
	
    app_router.on('route:categoriapromociones', function(ciudadId, categoriaId){
		$("footer").show();
		
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({css:'promociones',titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/categoria-promociones/" + categoriaId, link : "#ficha-promocion/"});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );

		
		
		
    });
	
    app_router.on('route:ofertaspromociones', function(ciudadId){
		$("footer").show();
				
		require(
            ['views/PromocionesView'],
            function(PromocionesView){
				//if (PromocionesViewElemento == false){
					var plantilla = new PromocionesView({css:"promociones", titulo: vars.getTituloActual(), link : "#ficha-promocion/", ciudad:ciudadId, seccion:0});
					//AppSlider.slidePage(PromocionesViewElemento.render().$el);
					appView.showView(plantilla);
				/*}
				else{
					PromocionesViewElemento.cargaseccion(0);
					AppSlider.saveHistory();

				}*/
				
				
				$("div.page-center div.scroller").css('transform', "translateY("+((parseInt(self.$("div.nav-pestanas").height()) ) + "px")+")" );

            }
        );
		
		
		
		

    });
    app_router.on('route:ofertaspromocionesmasvistas', function(ciudadId){
		$("footer").show();
		
		require(
            ['views/PromocionesView'],
            function(PromocionesView){
				//if (PromocionesViewElemento == false){
					PromocionesViewElemento = new PromocionesView({css:"promociones", titulo: vars.getTituloActual(), link : "#ficha-promocion/", ciudad:ciudadId, seccion:1});
					//AppSlider.slidePage(PromocionesViewElemento.render().$el);
					appView.showView(PromocionesViewElemento);
				/*}
				else{
					PromocionesViewElemento.cargaseccion(1);
					AppSlider.saveHistory();
				}*/
				
				$("div.page-center div.scroller").css('transform', "translateY("+((parseInt(self.$("div.nav-pestanas").height()) ) + "px")+")" );

            }
        );

    });
	
    app_router.on('route:ofertaspromocionesporsector', function(ciudadId){
		$("footer").show();
		
		require(
            ['views/PromocionesView'],
            function(PromocionesView){
				if (PromocionesViewElemento == false){
					PromocionesViewElemento = new PromocionesView({css:"iconos", titulo: vars.getTituloActual(), link : "#ficha-promocion/", ciudad:ciudadId, seccion:2});
					//AppSlider.slidePage(PromocionesViewElemento.render().$el);
					appView.showView(PromocionesViewElemento);
				}
				else{
					PromocionesViewElemento.cargaseccion(2);
					AppSlider.saveHistory();
				}
				
				$("div.page-center div.scroller").css('transform', "translateY("+((parseInt(self.$("div.nav-pestanas").height()) ) + "px")+")" );

				

            }
        );

    });
	
    app_router.on('route:ficha-promocion', function(fichaId){
		$("footer").show();
		
		PromocionesViewElemento = false;
		require(
            ['views/FichaPromocionView'],
            function(FichaPromocionView){
				var plantilla = new FichaPromocionView({titulo: vars.getTituloActual() ,url: 'promocion/' + fichaId});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
		

    });


    app_router.on('route:yademas', function(ciudadId){
		$("footer").show();
		PromocionesViewElemento = false;
		
		require(
            ['views/YademasView'],
            function(YademasView){
				var plantilla = new YademasView({titulo: vars.getTituloActual()});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
    });

    app_router.on('route:misplanes', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			vars.putSeccion("Mis planes");

			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/MisPlanesView'],
				function(MisPlanesView){
					var plantilla = new MisPlanesView({titulo: vars.getTituloActual() ,url: 'misplanes/'});
					//AppSlider.slidePage(plantilla.render().$el);
					appView.showView(plantilla);
					//$el.find("a.back-button").on("click",function(e){vars.goBack();});
	
				}
			);
			
			
		}
    });
    app_router.on('route:misplanes_comercios', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			vars.putSeccion("Mis planes");

			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/listado/ListadoView'],
				function(ListadoView){
					var plantilla = new ListadoView({css:"comercios misplanes", titulo:"Tiendas y restaurantes", url:"/planesusuario/comercios" + "?h=" + vars.login["hash"], link : "#ficha/", listadomisplanes : true,cache:false});
					//AppSlider.slidePage(plantilla.render().$el);
					appView.showView(plantilla);
				}
			);
			
		}
    });
    app_router.on('route:misplanes_promociones', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			vars.putSeccion("Mis planes");

			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/listado/ListadoView'],
				function(ListadoView){
					var plantilla = new ListadoView({css:"promociones misplanes", titulo:"Ofertas y cupones", url:"/planesusuario/promociones" + "?h=" + vars.login["hash"], link : "#ficha-promocion/", listadomisplanes : true,cache:false});
					//AppSlider.slidePage(plantilla.render().$el);
					appView.showView(plantilla);
				}
			);
			
		}
    });
    app_router.on('route:misplanes_eventos', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			vars.putSeccion("Mis planes");

			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/listado/ListadoView'],
				function(ListadoView){
					var plantilla = new ListadoView({css:"eventos misplanes", titulo:"Eventos", url:"/planesusuario/eventos" + "?h=" + vars.login["hash"], link : "#ficha-evento/", listadomisplanes : true,cache:false});
					//AppSlider.slidePage(plantilla.render().$el);
					appView.showView(plantilla);
	
				}
			);
			
		}
    });
    app_router.on('route:misplanes_turismo', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			vars.putSeccion("Mis planes");

			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/listado/ListadoView'],
				function(ListadoView){
					var plantilla = new ListadoView({css:"turismo misplanes", titulo:"Lugares de interés", url:"/planesusuario/turismo" + "?h=" + vars.login["hash"], link : "#ficha-quevisitar/", listadomisplanes : true,cache:false});
					//AppSlider.slidePage(plantilla.render().$el);
					appView.showView(plantilla);
	
				}
			);
			
		}
    });
	
    app_router.on('route:misdatos', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/MisDatosView'],
				function(MisDatosView){
					var plantilla = new MisDatosView({titulo: vars.getTituloActual() ,url: 'misplanes/'});
					//AppSlider.slidePage(plantilla.render().$el);
					appView.showView(plantilla);
					//$el.find("a.back-button").on("click",function(e){vars.goBack();});
	
				}
			);
			
			
		}
    });
	
	
	
	
	

    app_router.on('route:misfavoritos', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/MisFavoritosView'],
				function(MisFavoritosView){
					var plantilla = new MisFavoritosView({titulo: vars.getTituloActual() ,url: 'misfavoritos/'});
					//AppSlider.slidePage(plantilla.render().$el);
					appView.showView(plantilla);
					//$el.find("a.back-button").on("click",function(e){vars.goBack();});
	
				}
			);
			
			
		}
    });



    app_router.on('route:quevisitar', function(ciudadId){
		$("footer").show();
		PromocionesViewElemento = false;
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({css:"iconos", titulo:"Guía turística", url:"ciudad/" + ciudadId + "/turismo", link : "#ciudad/"+ciudadId+"/quevisitar/"});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);

            }
        );

		
    });


    app_router.on('route:quevisitarcategoria', function(ciudadId, categoriaId){
		$("footer").show();
		
		PromocionesViewElemento = false;
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/turismo/" + categoriaId, link : "#ficha-quevisitar/"});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);

            }
        );

		
    });

    app_router.on('route:quevisitarficha', function(fichaId){
		$("footer").show();
		
		PromocionesViewElemento = false;
				
		require(
            ['views/FichaTurismoView'],
            function(FichaTurismoView){
				var plantilla = new FichaTurismoView({titulo: vars.getTituloActual() ,url: 'turismo/' + fichaId});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
		
    });

	
    app_router.on('route:turismomapa', function(comercioId){
		
		PromocionesViewElemento = false;
		require(
            ['views/MapView'],
            function(MapView){
				$("footer").hide();
				var plantilla = new MapView({url: 'turismo/' + comercioId + "/mapa" });
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
    });
    app_router.on('route:salircuenta', function(comercioId){
		
		PromocionesViewElemento = false;
		vars.salirCuenta();
    });
    app_router.on('route:cambiaridioma', function(comercioId){
		$("footer").hide();
		PromocionesViewElemento = false;
		
		require(
			['views/CambiarIdiomaView'],
			function(CambiarIdiomaView){
				var plantilla = new CambiarIdiomaView({titulo: vars.getTituloActual()});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
				//$el.find("a.back-button").on("click",function(e){vars.goBack();});

			}
		);
		
    });

    app_router.on('route:tapas', function(ciudadId){
		$("footer").show();
		PromocionesViewElemento = false;
		require(
			['views/TapasPortadaView'],
			function(TapasPortadaView){
				var plantilla = new TapasPortadaView({titulo: vars.getTituloActual(), ciudad:ciudadId});
				appView.showView(plantilla);
			}
		);
		
    });
    app_router.on('route:empiezatapear', function(ciudadId){
		$("footer").show();
		PromocionesViewElemento = false;
		require(
			['views/TapasView'],
			function(TapasView){
				var plantilla = new TapasView({titulo: vars.getTituloActual(), ciudad:ciudadId});
				appView.showView(plantilla);
			}
		);
		
    });


    app_router.on('route:fichaTapa', function(fichaId){
		$("footer").show();
		
		PromocionesViewElemento = false;
		require(
            ['views/FichaTapaView'],
            function(FichaTapaView){
				var plantilla = new FichaTapaView({titulo: vars.getTituloActual() , url: 'tapa/' + fichaId});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
    });

    app_router.on('route:farmaciaDeGuardia', function(ciudadId){
		$("footer").show();
		PromocionesViewElemento = false;
		require(
			['views/FarmaciasView'],
			function(FarmaciasView){
				var plantilla = new FarmaciasView({titulo: vars.getTituloActual(), ciudad:ciudadId});
				appView.showView(plantilla);
			}
		);
    });

    app_router.on('route:baresYRestaurantes', function(ciudadId, categoriaId){
		$("footer").show();
		
		PromocionesViewElemento = false;
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/baresyrestaurantes", link : "#ficha/"});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);

            }
        );

		
    });
	
	

    app_router.on('route:telefonosDeInteres', function(){
        require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				$("footer").show();
				vars.noticiasCache = Array();
				var plantilla = new ListadoView({titulo: vars.getTituloActual(), url:"ciudad/" + vars.ciudad + "/telefonos-interes", link : "#", css: "eventos telefonos-de-interes", externo: true});
				//AppSlider.slidePage(plantilla.render().$el);
				appView.showView(plantilla);
            }
        );
    });


	
	// Al hacer click en info, guardar titulo Información
	$(document).on('click','a[href="#info"]',function(e){
		//e.preventDefault();
		vars.putSeccion("Información");
	});

	
    Backbone.history.start();	
  };
  return {
    initialize: initialize
  };
});