define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/EventosView.html',
  'text!tpl/calendario/clndr-template.html',
  'vars',
  'clndr',
], function($, _, Backbone, EventosTpl, clndrTpl, vars, clndr){
	
  HomeView = Backbone.View.extend({
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var self = this;
		moment.lang("es");
		var data = {titulo:"Eventos",ciudad:vars.ciudad};
		var compiledTemplate = _.template( EventosTpl, data );

		this.$el.html(compiledTemplate);		

		if (typeof(vars.cacheeventoscategoria) != "undefined" && vars.cacheeventoscategoria != ""){
			url = url_datos + "ciudad/"+vars.ciudad+"/eventos/filtro/"+vars.cacheeventoscategoria+"?l=" + language;
		}
		else{
			url = url_datos + "ciudad/"+vars.ciudad+"/eventos?l=" + language;
		}

		$.ajax({
			type: "GET",
			url: url,
			success:function(result){			
				var obj = JSON.parse(result);
				self.$("div.loading").fadeOut();
				// Obtenemos fechas y pasamos a calendario
				tamano = obj["fechas"].length;
				
				var aux = Array();
				for(i=0;i<tamano;i++){
					aux.push({date:obj["fechas"][i]});
				}
				self.calendarioInstance.setEvents(aux);
				// Montamos eventos tipos
				num_tipos = obj["eventos_tipos"].length;

				//rellenamos el select
				//self.$el.find(".calendar").before('<select class="eventos_select1"><option value="0">Todas las categorias</option></select>');				
				//totaltipos = self.arrayTipoEventos.length;
				/*for(j=0;j<totaltipos;j++){
					self.$("select.eventos_select1").append('<option>'+self.arrayTipoEventos[j]+'</option>');
				}*/
				//self.$("div.filtro ul").append('<li><span class="color" style="background:#ed495a"></span>Todos</li>');
				for(i=0;i<num_tipos;i++){
					//console.log(obj["eventos_tipos"][i]["nombre"]);
					elemento = '<option value="'+obj["eventos_tipos"][i]["id"]+'" style="background:'+obj["eventos_tipos"][i]["color"]+'" data-color="'+obj["eventos_tipos"][i]["color"]+'">';
					if (obj["eventos_tipos"][i]["color"] != ''){
						elemento += '<span class="color" style="background:'+obj["eventos_tipos"][i]["color"]+'"></span>';
					}
					elemento += obj["eventos_tipos"][i]["nombre"];
					elemento += '</option>';
					
					self.$el.find("select.eventos_select1").append(elemento);
				}
				//seleccionamos el elemento en el select
				//self.$("div.filtro ul li:first-child").addClass("select");
				if (typeof(vars.cacheeventoscategoria) != "undefined" && vars.cacheeventoscategoria != ""){
					self.$el.find('select.eventos_select1 option[value="'+vars.cacheeventoscategoria+'"]').attr("selected","selected");
					self.$el.find("select.eventos_select1").trigger("change");

					self.$el.find('select.eventos_select1 option[value="'+vars.cacheeventoscategoria+'"]').attr("selected","selected");


					color = self.$el.find("select.eventos_select1").find("option:selected").attr("data-color");

					// Cambiamso color a bolitas
					self.$(".calendar .css_temporal").remove();
					self.$(".calendar").append('<style class="css_temporal">.calendar .clndr-grid .days .day.event .day-number:before,.calendar .clndr-grid .days .empty.event .day-number:before{background:'+color+' !important;}</style>');

				}
				else{
					color = "#ed495a";
				}				
				self.color = color;

				
				//no hace nada?
	/*			self.$("div.filtro ul li").on("click",function(){
					// Ponemos cargando
					self.$("div.loading").fadeIn();
					// Asignamos select al filtro
					$(this).parent().find("li.select").removeClass("select");
					$(this).addClass("select");		
					
					// Si no hay id, es porque quiere todos los resultados
					if (typeof($(this).attr("rel-id")) != "undefined" && $(this).attr("rel-id") != ""){
						url = url_datos + "ciudad/"+vars.ciudad+"/eventos/filtro/"+$(this).attr("rel-id")+"?l=" + language;
						color = $(this).find("span.color").css("background");
					}
					else{
						url = url_datos + "ciudad/"+vars.ciudad+"/eventos?l=" + language;
						color = "#ed495a";
					}
					self.color = color;

					
					// Obtenemos datos y procesamos
					$.ajax({
						type: "GET",
						url: url,
						success:function(result){
							//console.log(result);
							var obj = JSON.parse(result);
							self.$("div.loading").fadeOut();
							// Obtenemos fechas y pasamos a calendario
							tamano = obj["fechas"].length;
							
							var aux = Array();
							for(i=0;i<tamano;i++){
								aux.push({date:obj["fechas"][i]});
							}
							self.calendarioInstance.setEvents(aux);
							
							// Cambiamso color a bolitas
							self.$(".calendar .css_temporal").remove();
							self.$(".calendar").append('<style class="css_temporal">.calendar .clndr-grid .days .day.event .day-number:before,.calendar .clndr-grid .days .empty.event .day-number:before{background:'+self.color+' !important;}</style>');
						}
					});
				});	*/
			}
		});	
		//var $select = self.$el.find("select.eventos_select1");

		//cuando seleccionamos tipo evento del select
		self.$el.find("select.eventos_select1").on("change",function(e){
			//e.preventDefault();
			// Ponemos cargando
			self.$("div.loading").fadeIn();

			if (typeof($(this).val()) != "undefined" && $(this).val() != "" && $(this).val() != "0"){
				url = url_datos + "ciudad/"+vars.ciudad+"/eventos/filtro/"+$(this).val()+"?l=" + language;
				color = $(this).find("option:selected").attr("data-color");
				vars.cacheeventoscategoria = $(this).val();
			}
			else{
				url = url_datos + "ciudad/"+vars.ciudad+"/eventos?l=" + language;
				color = "#ed495a";
				vars.cacheeventoscategoria = "";
			}
			self.color = color;

			// Obtenemos datos y procesamos
			$.ajax({
				type: "GET",
				url: url,
				success:function(result){
					//console.log(result);
					var obj = JSON.parse(result);
					self.$("div.loading").fadeOut();
					// Obtenemos fechas y pasamos a calendario
					tamano = obj["fechas"].length;
					
					var aux = Array();
					for(i=0;i<tamano;i++){
						aux.push({date:obj["fechas"][i]});
					}
					self.calendarioInstance.setEvents(aux);
					
					// Cambiamso color a bolitas
					self.$(".calendar .css_temporal").remove();
					self.$(".calendar").append('<style class="css_temporal">.calendar .clndr-grid .days .day.event .day-number:before,.calendar .clndr-grid .days .empty.event .day-number:before{background:'+self.color+' !important;}</style>');
				}
			});
			actualiza($(this).val());
		});

		
		// this will use clndr's default template, which you probably don't want.
		this.calendarioInstance = this.$("div.calendar").clndr({
			template: clndrTpl,
			weekOffset: 0,
			daysOfTheWeek: [ 'LU', 'MA', 'MI', 'JU', 'VI', 'SA','DO'],
			  constraints: {
				startDate: new Date()
			  },
			events: [
			/**{ date: '2014-01-16'},
			{ date: '2014-01-19'},
			{ date: '2014-01-22'},			
			{ date: '2014-01-26'},
			{ date: '2014-02-26'},
			{ date: '2014-03-26'},
			{ date: '2014-06-26'},*/
			],
			clickEvents: {
				click: function(target) {
				  if (target.events.length > 0){
					window.location.hash = "#ciudad/"+vars.ciudad+"/eventos/" + target.date._a[2]+"-"+(target.date._a[1]+1)+"-"+target.date._a[0];
					vars.putSeccion(target.date._a[2]+"/"+(target.date._a[1]+1)+"/"+target.date._a[0]);
				  }
				  
				}
			},
		});


		function actualiza(valor){
			var options = self.$el.find("select.eventos_select1").html();
			self.$el.find("select.eventos_select1").html("");
			self.$el.find("select.eventos_select1").html(options);
			self.$el.find("select.eventos_select1").val(valor);
		}

        return this;
    },
	initialize: function(options) {
	    _.bindAll(this, 'render'); // every function that uses 'this' as the current object should be in here
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goback();
    },
  });
  // Our module now returns our view
  return HomeView;
});