// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/FarmaciasView.html',
  'text!tpl/FarmaciasItem.html',
  'vars'
], function($, _, Backbone, FarmaciasView, FarmaciasItem, vars){ 
  Farmacias = Backbone.View.extend({
	ciudad : 0,
	intervaloCarrusel: null,
	stopintervalo: false,
	events: {
	  'click a.back-button': 'goBack',
	  'click div.listado a': 'click'
	},
    render: function(){
		var self = this;

		titulo = "Farmacia de guardia";

		this.data =  {titulo: titulo ,ciudad: self.ciudad, logueado: vars.login["logueado"]};

		self.compiledTemplate = _.template( FarmaciasView, this.data );
		//self.compiledTemplate = 'test';
		self.$el.html(self.compiledTemplate);

		this.$el.find("div.loading").show();
		
		$.ajax({
			type: "GET",
			url: url_datos + "/ciudad/"+ this.ciudad + "/farmacia?l=" + language + "&h=" + localStorage.getItem("hash"),
			cache: vars.cacheActivo,
			success:function(result){
				console.log(result);
				localStorage.setItem('farmaciaCache' + self.ciudad, result)
				self.rellenarDatos(localStorage.getItem('farmaciaCache' + self.ciudad));
			}
		});

		
        return this;
    },
	initialize: function(options) {
		this.ciudad = options.ciudad;
    },
	rellenarDatos: function(result){
		var self = this;
		self.$el.find("div.loading").fadeOut("fast");

		var obj = JSON.parse(result);
		obj.localizacion = false;

		console.log(obj);

		if(typeof(obj.nombre) != "undefined"){

			this.idcanvas = Math.floor((Math.random()*100)+1);
			obj.idcanvas =  "googlemaps-" + this.idcanvas;

	    	//$('#' + obj.idcanvas).hide();

			if (typeof(obj.latitud) != "undefined" && typeof(obj.longitud) != "undefined" ){
				if (obj.latitud != 0 && obj.longitud != 0 && obj.latitud != "" && obj.longitud != ""){
					obj.distancia = vars.Distancia( obj.latitud, obj.longitud);
					obj.localizacion = true;
				}
			}

			//console.log(obj);
			listado =  _.template( FarmaciasItem, obj);

			//self.compiledTemplate = 'test';
			self.$el.find(".listado").html(listado);

			require(
				['gmaps'],
				function(gmaps){

					var direccion = obj.direccion;
					if (typeof(obj.latitud) != "undefined"){

						map = new GMaps({
							div: '#' + obj.idcanvas,
							lat: obj.latitud,
							lng: obj.longitud
						});

						$('#' + obj.idcanvas).show();

						map.setCenter(obj.latitud, obj.longitud);

						map.addMarker({
							lat: obj.latitud,
							lng: obj.longitud
						});

						if (vars.posicion.latitud != 0 && vars.posicion.longitud != 0){
							var tuposicion = new google.maps.LatLng(vars.posicion.latitud,vars.posicion.longitud);
			
							map.drawRoute({
								origin: [vars.posicion.latitud, vars.posicion.longitud],
								destination: [obj.latitud, obj.longitud],
								travelMode: 'walking',
								strokeColor: '#131540',
								strokeOpacity: 0.6,
								strokeWeight: 6
							});
							map.addMarker({
								lat: vars.posicion.latitud,
								lng: vars.posicion.longitud,
								title: 'Estas aquí',
								icon: "https://maps.gstatic.com/mapfiles/ms2/micons/red-dot.png",
								infoWindow: {
									content: '<div class="infowindow"><p>Estás aquí</p></div>'
								}
							});				
						}
					}
					else{
						//alert(obj.direccion+ " " + obj.municipio);
						var direccionOk = obj.direccion+ ", " + obj.municipio+",Alicante,España";
						//console.log(direccionOk);
						GMaps.geocode({
						 // address: direccion.replace("º","")+" - " + obj.municipio ,
						 address: direccionOk,
						  region: "Spain" ,
						  callback: function(results, status){
						  	//console.log("status: "+status);
						    if(status=='OK'){
								map = new GMaps({
									div: '#' + obj.idcanvas,
									lat: -12.043333,
									lng: -77.028333
								});

						      	$('#' + obj.idcanvas).show();

								var latlng = results[0].geometry.location;
								map.setCenter(latlng.lat(), latlng.lng());
								map.addMarker({
									lat: latlng.lat(),
									lng: latlng.lng()
								});

								if (vars.posicion.latitud != 0 && vars.posicion.longitud != 0){
									var tuposicion = new google.maps.LatLng(vars.posicion.latitud,vars.posicion.longitud);
					
									map.drawRoute({
										origin: [vars.posicion.latitud, vars.posicion.longitud],
										destination: [latlng.lat(), latlng.lng()],
										travelMode: 'walking',
										strokeColor: '#131540',
										strokeOpacity: 0.6,
										strokeWeight: 6
									});
									map.addMarker({
										lat: vars.posicion.latitud,
										lng: vars.posicion.longitud,
										title: 'Estas aquí',
										icon: "https://maps.gstatic.com/mapfiles/ms2/micons/red-dot.png",
										infoWindow: {
											content: '<div class="infowindow"><p>Estás aquí</p></div>'
										}
									});
					
									obj.distancia = vars.Distancia( latlng.lat().toString(), latlng.lng().toString());
									$(".container-distancia").html('<p class="distancia"><span class="icono icon-localizacion"></span><span class="distancia_a_comercio">'+obj.distancia+'</span>Km</p>');
									obj.localizacion = true;
								}
						    }
						    else{
						    	$('#' + obj.idcanvas).hide();
						    }
						  }
						});
					}
				}
			);
			if (self.$("div.carrusel div.item").length > 1)
		{
			
			var hammertime = self.$("div.carrusel div.item").hammer();
			self.stopintervalo = false;
			self.$("div.carrusel div.item").css("left","100%");
			self.$("div.carrusel div.item:eq(0)").css("left","0");

			hammertime.on("swipeleft", function(ev) {
				ev.preventDefault();
				
				proximo = $(this).next();
				
				if (proximo.length <= 0){
					proximo = $(this).parent().find("div.item:eq(0)");
				}
				
				if (!$(this).is(":animated") && !proximo.is(":animated") ){
					$(this).animate({left:"-100%"});
					self.$("div.carrusel div.control span.select").removeClass("select");
					self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
					
					proximo.css({left:"100%"}).show();
					proximo.animate({left:0});
					
					self.stopintervalo = true;
				}
			});
			hammertime.on("swiperight", function(ev) {
				ev.preventDefault();
				proximo = $(this).prev();
				
				
				if (proximo.length <= 0){
					proximo = $(this).parent().find("div.item:last-child");
				}
				
				if (!$(this).is(":animated") && !proximo.is(":animated") ){
					$(this).animate({left:"100%"});
					self.$("div.carrusel div.control span.select").removeClass("select");
					self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
					
					proximo.css({left:"-100%"}).show();
					proximo.animate({left:0});
		
					self.stopintervalo = true;
				}

			});

			this.$(".scroller").on("scroll",function(e){self.stopintervalo = true;});

			clearInterval(self.intervaloCarrusel);
				self.intervaloCarrusel = setInterval(function(){
					if (!self.stopintervalo){
						indexActual = self.$("div.carrusel div.control span.select").index();
						
						itemActual = self.$("div.carrusel div.item:eq("+indexActual+")");
						
						
						
						itemActual.animate({left:"-100%"});
						
						proximo = itemActual.next();
						
						if (proximo.length <= 0){
							proximo = itemActual.parent().find("div.item:eq(0)");
						}
						
						self.$("div.carrusel div.control span.select").removeClass("select");
						self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
			
						
						proximo.css({left:"100%"}).show();
						proximo.animate({left:0});
					}
					else{
						self.stopintervalo = false;
					}
				},3000);
		}
		}
		else{
			self.$el.find(".listado").html('<p class="no_results">No se encontró resultados. </p>');
		}
	},
	goBack: function(e) {
		e.preventDefault();
		vars.goback();
    },
	click: function(event) {
		//e.preventDefault();
		vars.putSeccion($(event.currentTarget).find("span.titulo").html());
    },
    onClose: function(){
		clearInterval(self.intervaloCarrusel);
		self.intervaloCarrusel = null;
	}
  });
  // Our module now returns our view
  return Farmacias;
});