// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/ficha/FichaView.html',
  'text!tpl/ficha/FichaEventosTexto.html',
  'models/ItemListado',
  'text!tpl/listado/ItemView.html',
  'vars',
  'moment',
  'modal'
], function($, _, Backbone, FichaViewTemplate, FichaEventosTexto, ItemListado, ItemViewTemp, vars, moment,modal){


  FichaView = Backbone.View.extend({ 
    url : "",
	intervaloCarrusel: null,
	stopintervalo: false,
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var data = {titulo : vars.getTituloActual()};
		var compiledTemplate = _.template( FichaViewTemplate, data );
		this.$el.html(compiledTemplate);
		
		var self = this;
		
				
		
		var item = new ItemListado({url: url_datos + this.url + "?h=" + vars.login["hash"] + "&l=" + language,template: FichaViewTemplate});

		item.fetch({prefill:vars.cacheActivo, data: {},prefillSuccess:self.rellenarDatos, success: self.rellenarDatos});
		

        return this;
    },
	initialize: function(options) {
	     _.bindAll(this, 'render', 'eventos','rellenarDatos'); // every function that uses 'this' as the current object should be in here

		this.url = options.url;
		this.titulo = options.titulo;		
				//alert(vars.getTituloActual() + "asdfsdf");

		this.compartir = Array();
		this.compartir["mensaje"] = "";
		this.compartir["titulo"] = "";
		this.compartir["imagen"] = "";	
    },
	rellenarDatos: function(item){
		var self = this;
				if (typeof(item.attributes) == "undefined"){
					atributos = item;
				}
				else{
					atributos = item.attributes;
				}
				var data = {};
				data.titulo = atributos.nombre;
				data.descripcion = atributos.descripcion;
				data.direccion = atributos.direccion;
				data.codigopostal = atributos.cp;
				data.poblacion = atributos.poblacion;
				data.provincia = atributos.provincia;
				data.telefono = atributos.telefono;
				data.email = atributos.email;
				data.id = atributos.id;
				data.id_comercio = atributos.id_comercio;
				data.imagen = atributos.imagen;
				data.imagen_comercio = atributos.imagen_comercio;
				data.titulo_comercio = atributos.titulo_comercio;
				data.cupon = atributos.cupon;
				
				
				data.fechaini = moment(atributos.fecha_inicio).format("LLL");

				if (atributos.fecha_fin != "0000-00-00 00:00:00")
					data.fechafin = moment(atributos.fecha_fin).format("LLL");

				data.imagenes = Array()
				if (typeof(atributos.imagenes) != "undefined" )
					data.imagenes = atributos.imagenes;


				data.misplanes = false;
				if (typeof(atributos.misplanes) != "undefined" && atributos.misplanes > 0)
					data.misplanes = true;
				
				data.megusta = false;
				if (typeof(atributos.megusta) != "undefined" && atributos.megusta > 0)
					data.megusta = true;
				
				// Calculamos cuanto queda para que finalize, si es en una semana mostraremos un mensaje.
				var d1 = new Date();
				var d2 = new Date(atributos.fecha_fin);
				var diasfaltan = vars.DateDiff.inDays(d1, d2);
				
				if (diasfaltan <= 7 && diasfaltan >= 0){
					data.ultimosDias = diasfaltan;
				}
				self.data = data;

				var compiledTemplate = _.template( FichaEventosTexto, data );
				
				//$("#container > div.page:last-child #ficha").html(compiledTemplate);
				//self.mostrarFicha(item);
				self.$el.find("div.contenido").html(compiledTemplate);				

				self.compartir["mensaje"] = "El Sr Cayetano te recomienda: " + data.titulo +" " + data.direccion  + " "  + data.poblacion + " Fecha: " + data.fechaini;
				self.compartir["titulo"] = data.titulo;
				self.compartir["imagen"] = data.imagen;	
				
				
				self.$el.find("div.carrusel img").on("error",function(){$(this).attr("src","img/ficha-noimg.jpg");$(this).css("top",0)});				

				self.eventos();
	
	},
	eventos: function(e) {
		var self = this;
		
		self.$("a.miespacio").on("click",function(e){
			if (vars.login["logueado"] == false){
				location.hash = "#login";				
			}
			else{
					estado = (!self.$("a.miespacio").hasClass("activo"))?"activo":"desactivado";
					if(estado=="desactivado"){
						mensaje = "¿Estas seguro que deseas eliminarlo de tus planes?";
						botones = "Eliminar,Cancelar";
					}
					else{
						mensaje = "¿Estás seguro que deseas añadirlo a tus planes?";
						botones = "Añadir,Cancelar";
					}
					
					navigator.notification.confirm(
						mensaje,  // message
						function(boton){
							if(boton == 1){
								self.$("a.miespacio").addClass("cargando");
								
								$.ajax({
									type: "POST",
									url: url_datos + "anadiraplanes",
									data: {
										hash: vars.login["hash"],
										id_evento: self.data.id,
										estado: estado
									},
									success:function(result){
										var obj = JSON.parse(result);
										
										if (typeof(obj.estado) != "undefined" && obj.estado == "activo"){
											self.$("a.miespacio").removeClass("cargando");
											self.$("a.miespacio").addClass("activo");
											
											
											$("#especial-anadido-planes").height(52);
											setTimeout(function(){$("#especial-anadido-planes").height(0);},1000);

										}
										else{
											self.$("a.miespacio").removeClass("cargando");
											self.$("a.miespacio").removeClass("activo");
										}
				
									}
								});
							}
							
						},              // callback to invoke with index of button pressed
						'Mis planes',            // title
						botones       // buttonLabels
					);
				
			}			
			
			e.preventDefault();
		});
		
		
		self.$("a.share").on("click",function(e){
			//window.plugins.socialsharing.share(self.compartir["mensaje"], self.compartir["titulo"], self.compartir["imagen"]);
			modal.show($("div.compartir-dialog").html(),true);
			e.preventDefault();
		});

		
		$("#modal").on("click","div.compartir-modal a.facebook",function(event){

			var fbDialog = "https://www.facebook.com/dialog/feed?app_id=1377982829129309" 
			+ "&link=" +encodeURIComponent("http://www.srcayetano.com")
			+ "&name="+encodeURIComponent(self.compartir["titulo"])
			+ "&description="+encodeURIComponent(self.compartir["mensaje"])
			+ "&picture="+encodeURIComponent(self.compartir["imagen"])
			+ "&redirect_uri=" +encodeURIComponent("http://www.srcayetano.com");

			var ref = window.open(fbDialog, '_system', 'location=yes');

			ref.addEventListener('loadstart', function(event) {

			});
			ref.addEventListener('loadstop', function(event) {
			     var post_id = event.url.split("post_id=")[1];
			     var cancel_url = event.url.split("#")[0];
			     if(post_id != undefined){
			            setTimeout(function() {
			                ref.close();                    
			            }, 5000);
			     }
			     if(cancel_url != undefined && cancel_url == your_redirect_uri){
			            setTimeout(function() {
			                ref.close();                        
			            }, 1000);
			     }                         
			});
			ref.addEventListener('exit', function(event) {

			}); 
			event.preventDefault();
		});

		$("#modal").on("click","div.compartir-modal a.twitter",function(event){
			var tweeter_url = 'https://twitter.com/intent/tweet?source=webclient&text='+encodeURIComponent(self.compartir["mensaje"]+ " vía @srcayetano") ;

			var ref = window.open(tweeter_url, '_system', 'location=yes');
			ref.addEventListener('loadstart', function(event) {
			} );
			ref.addEventListener('loadstop', function(event) {

			     if(event.url == 'https://mobile.twitter.com/'){

			         setTimeout(function() {
			                    ref.close();
			         }, 1000);
			     }

			} );
			ref.addEventListener('exit', function(event) {

			} );

			event.preventDefault();
		});
		
		self.$("div.cuerpo a").on("click",function(event){
			window.open($(event.currentTarget).attr("href"),'_system','location=yes');
			event.preventDefault();
		});
		
		if (self.$("div.carrusel div.item").length > 1){
		
			var hammertime = self.$("div.carrusel div.item").hammer();
			self.stopintervalo = false;
			self.$("div.carrusel div.item").css("left","100%");
			self.$("div.carrusel div.item:eq(0)").css("left","0");

			hammertime.on("swipeleft", function(ev) {
				ev.preventDefault();
				
				proximo = $(this).next();
				
				if (proximo.length <= 0){
					proximo = $(this).parent().find("div.item:eq(0)");
				}
				
				if (!$(this).is(":animated") && !proximo.is(":animated") ){
					$(this).animate({left:"-100%"});
					self.$("div.carrusel div.control span.select").removeClass("select");
					self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
					
					proximo.css({left:"100%"}).show();
					proximo.animate({left:0});
					
					self.stopintervalo = true;
				}
			});
			hammertime.on("swiperight", function(ev) {
				ev.preventDefault();
				proximo = $(this).prev();
				
				
				if (proximo.length <= 0){
					proximo = $(this).parent().find("div.item:last-child");
				}
				
				if (!$(this).is(":animated") && !proximo.is(":animated") ){
					$(this).animate({left:"100%"});
					self.$("div.carrusel div.control span.select").removeClass("select");
					self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
					
					proximo.css({left:"-100%"}).show();
					proximo.animate({left:0});
		
					self.stopintervalo = true;
				}

			});

			this.$(".scroller").on("scroll",function(e){self.stopintervalo = true;});

			clearInterval(self.intervaloCarrusel);
				self.intervaloCarrusel = setInterval(function(){
					if (!self.stopintervalo){
						indexActual = self.$("div.carrusel div.control span.select").index();
						
						itemActual = self.$("div.carrusel div.item:eq("+indexActual+")");
						
						
						
						itemActual.animate({left:"-100%"});
						
						proximo = itemActual.next();
						
						if (proximo.length <= 0){
							proximo = itemActual.parent().find("div.item:eq(0)");
						}
						
						self.$("div.carrusel div.control span.select").removeClass("select");
						self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
			
						
						proximo.css({left:"100%"}).show();
						proximo.animate({left:0});
					}
					else{
						self.stopintervalo = false;
					}
				},3000);
		}


    },
	goBack: function(e) {
		e.preventDefault();
		vars.goback();
    },
	onClose: function(){
		clearInterval(self.intervaloCarrusel);
		self.intervaloCarrusel = null;
	}
  });
  // Our module now returns our view
  return FichaView;
});