// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/ficha/FichaView.html',
  'text!tpl/ficha/FichaTextoTapas.html',
  'models/ItemListado',
  'text!tpl/listado/ItemView.html',
  'socialsharing',
  'vars',
  'moment',
  'modal'
], function($, _, Backbone, FichaViewTemplate, FichaPromocionTexto, ItemListado, ItemViewTemp, socialsharing, vars, moment, modal){


  FichaView = Backbone.View.extend({ 
    url : "",
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var data = {titulo : vars.getTituloActual()};
		var compiledTemplate = _.template( FichaViewTemplate, data );
		this.$el.html(compiledTemplate);
		
		var self = this;
		
				
		
		var item = new ItemListado({url: url_datos + this.url + "?h=" + localStorage.getItem("hash") +"&l=" + language,template: FichaViewTemplate});


		//Backbone.fetchCache.clearItem(url_datos + self.url + "?h=" + vars.login["hash"]);

		item.fetch({prefill:this.cacheActivo, data: {}, prefillSuccess: self.rellenarDatos, success: self.rellenarDatos});

        return this;
    },
	initialize: function(options) {
	     _.bindAll(this, 'render', 'eventos','rellenarDatos'); // every function that uses 'this' as the current object should be in here

		this.url = options.url;
		this.titulo = options.titulo;		
				//alert(vars.getTituloActual() + "asdfsdf");
		this.escupon = false;
		this.compartir = Array();
		this.compartir["mensaje"] = "";
		this.compartir["titulo"] = "";
		this.compartir["imagen"] = "";	
    },
	rellenarDatos:function(item){
		var self = this;
				if (typeof(item.attributes) == "undefined"){
					atributos = item;
				}
				else{
					atributos = item.attributes;
				}
				var data = {};
				data.titulo = atributos.nombre;
				data.descripcion = atributos.descripcion;
				data.direccion = atributos.direccion;
				data.codigopostal = atributos.cp;
				data.poblacion = atributos.poblacion;
				data.provincia = atributos.provincia;
				data.telefono = atributos.telefono;
				data.email = atributos.email;
				data.id = atributos.id;
				data.id_comercio = atributos.id_comercio;
				data.imagen = atributos.imagen;
				data.imagen_comercio = atributos.imagen_comercio;
				data.titulo_comercio = atributos.titulo_comercio;
				data.cupon = atributos.cupon;
				data.web = atributos.web;
				data.horario= atributos.horario;
				data.voto = 0;
				data.num_votos = 0;
				data.votos = atributos.votos;
				data.ruta_activa = parseInt(atributos.ruta_activa);


				if (typeof(atributos.voto) != "undefined"){
					data.voto = atributos.voto;
				}

				if (typeof(atributos.num_votos) != "undefined"){
					data.num_votos = parseInt(atributos.num_votos);
				}

				if (data.cupon == 1){
					self.escupon = true;
				}
				if (typeof(atributos.cupon_codigo) != "undefined" && atributos.cupon_codigo > 0)
					data.cupon_codigo = atributos.cupon_codigo;
				
				data.misplanes = false;
				if (typeof(atributos.misplanes) != "undefined" && atributos.misplanes > 0)
					data.misplanes = true;

				data.valido_hasta = moment(atributos.fecha_fin).format("LL");

				data.misplanes = false;
				if (typeof(atributos.misplanes) != "undefined" && atributos.misplanes > 0)
					data.misplanes = true;
				
				data.megusta = false;
				if (typeof(atributos.megusta) != "undefined" && atributos.megusta > 0)
					data.megusta = true;
					
				if (typeof(atributos.unidades) != "undefined" ){
					data.unidades = atributos.unidades;
				}
				
				if (typeof(atributos.latitud) != "undefined" && typeof(atributos.longitud) != "undefined" ){
					if (atributos.latitud != 0 && atributos.longitud != 0 && atributos.latitud != "" && atributos.longitud != ""){
						data.distancia = vars.Distancia( atributos.latitud, atributos.longitud);
						data.localizacion = true;
					}
				}

				data.logueado = true;
				if (vars.login["logueado"] == true){
					data.logueado = true;
				}

				// Calculamos cuanto queda para que finalize, si es en una semana mostraremos un mensaje.
				var d1 = new Date();
				var d2 = new Date(atributos.fecha_fin);
				var diasfaltan = vars.DateDiff.inDays(d1, d2);
				
				if (diasfaltan <= 7 && diasfaltan >= 0){
					data.ultimosDias = diasfaltan;
				}
				self.data = data;

				var compiledTemplate = _.template( FichaPromocionTexto, data );



				self.compartir["mensaje"] = "El Sr Cayetano te recomienda la promoción: " + data.titulo + " ofrecida por " + data.titulo_comercio + " " + data.poblacion + " " + data.telefono;
				self.compartir["titulo"] = data.titulo;
				self.compartir["imagen"] = data.imagen;	
				//$("#container > div.page:last-child #ficha").html(compiledTemplate);
				//self.mostrarFicha(item);
				self.$el.find("div.contenido").html(compiledTemplate);				
				self.$el.find("div.carrusel img").on("error",function(){$(this).attr("src","img/ficha-noimg.jpg");$(this).css("top",0)});				

				self.eventos();

	},
	eventos: function(e) {
		var self = this;
		
		self.$("div.cuerpo a").on("click",function(event){
			window.open($(event.currentTarget).attr("href"),'_system','location=yes');
			event.preventDefault();
		});
		
		self.$("a.web").on("click",function(event){
			window.open($(event.currentTarget).attr("href"),'_system','location=yes');
			event.preventDefault();
		});

		
		self.$("a.share").on("click",function(e){
			//window.plugins.socialsharing.share(self.compartir["mensaje"], self.compartir["titulo"], self.compartir["imagen"]);
			modal.show($("div.compartir-dialog").html(),true);
			e.preventDefault();
		});

		
		$("#modal").on("click","div.compartir-modal a.facebook",function(event){

			var fbDialog = "https://www.facebook.com/dialog/feed?app_id=1377982829129309" 
			+ "&link=" +encodeURIComponent("http://www.srcayetano.com")
			+ "&name="+encodeURIComponent(self.compartir["titulo"])
			+ "&description="+encodeURIComponent(self.compartir["mensaje"])
			+ "&picture="+encodeURIComponent(self.compartir["imagen"])
			+ "&redirect_uri=" +encodeURIComponent("http://www.srcayetano.com");

			var ref = window.open(fbDialog, '_system', 'location=yes');

			ref.addEventListener('loadstart', function(event) {

			});
			ref.addEventListener('loadstop', function(event) {
			     var post_id = event.url.split("post_id=")[1];
			     var cancel_url = event.url.split("#")[0];
			     if(post_id != undefined){
			            setTimeout(function() {
			                ref.close();                    
			            }, 5000);
			     }
			     if(cancel_url != undefined && cancel_url == your_redirect_uri){
			            setTimeout(function() {
			                ref.close();                        
			            }, 1000);
			     }                         
			});
			ref.addEventListener('exit', function(event) {

			}); 
			event.preventDefault();
		});

		$("#modal").on("click","div.compartir-modal a.twitter",function(event){
			var tweeter_url = 'https://twitter.com/intent/tweet?source=webclient&text='+encodeURIComponent(self.compartir["mensaje"]+ " vía @srcayetano") ;

			var ref = window.open(tweeter_url, '_system', 'location=yes');
			ref.addEventListener('loadstart', function(event) {

			} );
			ref.addEventListener('loadstop', function(event) {

			     if(event.url == 'https://mobile.twitter.com/'){

			         setTimeout(function() {
			                    ref.close();
			         }, 1000);
			     }

			} );
			ref.addEventListener('exit', function(event) {
			} );

			event.preventDefault();
		});
		
		
		self.$("div.comercio_contacto a").on("click",function(e){
			vars.putSeccion($("div.comercio_contacto").find("h3 a").html());
		});
		


		self.$("a.votar-tapa:not(.desactivado)").on("click",function(e){
			if (!$(this).hasClass("desactivado")){
				if (vars.login["logueado"] == true){
					if (self.data.num_votos == 2){
						textoconfirm = "Mmm... ¿Estaba buena la tapa? Vótala como favorita, te queda 1 voto";
					}
					else{
						textoconfirm = "Mmm... ¿Estaba buena la tapa? Vótala como favorita, te quedan "+ (3 -self.data.num_votos)+" votos";
					}

					navigator.notification.confirm(
						textoconfirm,  // message
						function(boton){
							if(boton == 1){

								self.$("a.votar-tapa").addClass("cargando");

								$.ajax({
									type: "POST",
									url: url_datos + "/ciudad/"+ self.ciudad + "/tapas/votar?l=" + language + "&h=" + localStorage.getItem("hash"),
									cache: false,
									data:{
										tapa:self.data.id,
										hash:localStorage.getItem("hash")
									},
									success:function(result){
										var obj = JSON.parse(result);
										if (typeof(obj.estado) != "undefined" && obj.estado == "activo"){

											self.$("span.numero_votos").html(parseInt(self.$("span.numero_votos").html()) + 1);

											self.$("a.votar-tapa").addClass("desactivado").html('<span class="icono icon-premio"></span>Una de mis favoritas');
										}
										else if (typeof(obj.errores) !== "undefined"){
											navigator.notification.alert(
												obj.errores, 		 // message
												function(){},  			  // callback
												'Error!',            // title
												'Ok'                 // buttonName
											);
										}

										self.$("a.votar-tapa").removeClass("cargando");
									}
								});
							}
						},              // callback to invoke with index of button pressed
						'Votar tapa',            // title
						"Votar,Cancelar"       // buttonLabels
					);






				}
				else{
					navigator.notification.confirm(
						"Para votar, necesitas estar identificado.",  // message
						function(boton){
							if(boton == 1){
								localStorage.setItem("login-redirect",window.location.hash);
								window.location.hash = "#login";
							}
						},              // callback to invoke with index of button pressed
						'Votar tapa',            // title
						"Identifícate,Cancelar"       // buttonLabels
					);
				}


			}

	

	
			e.preventDefault();
		});
		
    },
	goBack: function(e) {
		e.preventDefault();
		localStorage.removeItem("login-redirect");
		vars.goback();
    },
  });
  // Our module now returns our view
  return FichaView;
});