// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/ficha/FichaView.html',
  'text!tpl/ficha/FichaTurismoTexto.html',
  'models/ItemListado',
  'text!tpl/listado/ItemView.html',
  'vars',
  'modal'
], function($, _, Backbone, FichaViewTemplate, FichaTexto, ItemListado, ItemViewTemp, vars, modal){


  FichaView = Backbone.View.extend({ 
    url : "",
	intervaloCarrusel: null,
	stopintervalo: false,
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		//console.log( vars.getTituloActual());
		var data = {titulo : vars.getTituloActual()};
		var compiledTemplate = _.template( FichaViewTemplate, data );
		this.$el.html(compiledTemplate);
		
		var self = this;
		
				
		
		var item = new ItemListado({url: url_datos + this.url + "?h=" + vars.login["hash"] + "&l=" + language,template: FichaViewTemplate});
		self.data = Array();

		item.fetch({prefill:vars.cacheActivo, data: {},prefillSuccess:self.rellenarDatos,success:self.rellenarDatos});
		

        return this;
    },
	initialize: function(options) {
	     _.bindAll(this, 'render', 'eventos','rellenarDatos'); // every function that uses 'this' as the current object should be in here


		this.url = options.url;
		this.titulo = options.titulo;		
		this.compartir = Array();
		this.compartir["mensaje"] = "";
		this.compartir["titulo"] = "";
		this.compartir["imagen"] = "";	
    },
	rellenarDatos: function(item){
		var self = this;
				data = {};
				data.titulo = item.attributes.nombre;
				data.descripcion = item.attributes.descripcion;
				data.direccion = item.attributes.direccion;
				data.codigopostal = item.attributes.cp;
				data.poblacion = item.attributes.poblacion;
				data.provincia = item.attributes.provincia;
				data.telefono = item.attributes.telefono;
				data.email = item.attributes.email;
				data.id = item.attributes.id;
				data.imagen = item.attributes.imagen;
				data.web = item.attributes.web;
				data.localizacion = false;
								  
				data.imagenes = Array()
				if (typeof(item.attributes.imagenes) != "undefined" )
					data.imagenes = item.attributes.imagenes;
				  
								  
				delete data.distancia;
				
				if (typeof(item.attributes.latitud) != "undefined" && typeof(item.attributes.longitud) != "undefined" ){
					if (item.attributes.latitud != 0 && item.attributes.longitud != 0 && item.attributes.latitud != "" && item.attributes.longitud != ""){
						data.distancia = vars.Distancia( item.attributes.latitud, item.attributes.longitud);
						data.localizacion = true;
					}
				}

				data.misplanes = false;
				if (typeof(item.attributes.misplanes) != "undefined" && item.attributes.misplanes > 0)
					data.misplanes = true;

				self.data = data;
				var compiledTemplate = _.template( FichaTexto, data );
				
				
				self.compartir["mensaje"] = "El Sr Cayetano te recomienda: " + data.titulo + " " + data.direccion + " "  + data.poblacion + " " + data.telefono;
				self.compartir["titulo"] = data.titulo;
				self.compartir["imagen"] = data.imagen;


				//$("#container > div.page:last-child #ficha").html(compiledTemplate);
				//self.mostrarFicha(item);
				self.$el.find("div.contenido").html(compiledTemplate);				
				

				self.eventos();
	},
	eventos: function(e) {
		var self = this;
		
		self.$("div.pestanas div.pestana").hide();
		self.$("div.pestanas div.pestana:eq(0)").show();
		
		self.$("div.pestanas div.nav a").on("click",function(e){
			self.$("div.pestanas div.nav a.abierto").removeClass("abierto");
			$(this).addClass("abierto");
			
			
			e.preventDefault();
			e.stopImmediatePropagation();
			self.$("div.pestanas div.pestana").hide();
			self.$("div.pestanas div.pestana:eq("+$(this).index()+")").show();
			
		});
		

		if (self.$("div.carrusel div.item").length > 1){
		
			var hammertime = self.$("div.carrusel div.item").hammer();
			self.stopintervalo = false;
			self.$("div.carrusel div.item").css("left","100%");
			self.$("div.carrusel div.item:eq(0)").css("left","0");


			hammertime.on("swipeleft", function(ev) {
				ev.preventDefault();
				
				proximo = $(this).next();
				
				if (proximo.length <= 0){
					proximo = $(this).parent().find("div.item:eq(0)");
				}
				
				if (!$(this).is(":animated") && !proximo.is(":animated") ){
					$(this).animate({left:"-100%"});
					self.$("div.carrusel div.control span.select").removeClass("select");
					self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
					
					proximo.css({left:"100%"}).show();
					proximo.animate({left:0});
					
					self.stopintervalo = true;
				}
			});
			hammertime.on("swiperight", function(ev) {
				ev.preventDefault();
				proximo = $(this).prev();
				
				
				if (proximo.length <= 0){
					proximo = $(this).parent().find("div.item:last-child");
				}
				
				if (!$(this).is(":animated") && !proximo.is(":animated") ){
					$(this).animate({left:"100%"});
					self.$("div.carrusel div.control span.select").removeClass("select");
					self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
					
					proximo.css({left:"-100%"}).show();
					proximo.animate({left:0});
		
					self.stopintervalo = true;
				}

			});

			this.$(".scroller").on("scroll",function(e){self.stopintervalo = true;});

			clearInterval(self.intervaloCarrusel);
				self.intervaloCarrusel = setInterval(function(){
					if (!self.stopintervalo){
						indexActual = self.$("div.carrusel div.control span.select").index();
						
						itemActual = self.$("div.carrusel div.item:eq("+indexActual+")");
						
						
						
						itemActual.animate({left:"-100%"});
						
						proximo = itemActual.next();
						
						if (proximo.length <= 0){
							proximo = itemActual.parent().find("div.item:eq(0)");
						}
						
						self.$("div.carrusel div.control span.select").removeClass("select");
						self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
			
						
						proximo.css({left:"100%"}).show();
						proximo.animate({left:0});
					}
					else{
						self.stopintervalo = false;
					}
				},3000);
		}
		


		$("div.listado.promociones a").on("click",function(e){
			self.clickpromo(e);
		});
		
		self.$("a.web").on("click",function(event){
			window.open($(event.currentTarget).attr("href"),'_system','location=yes');
			event.preventDefault();
		});

		self.$("div.cuerpo a").on("click",function(event){
			window.open($(event.currentTarget).attr("href"),'_system','location=yes');
			event.preventDefault();
		});
		

		self.$("a.share").on("click",function(e){
			//window.plugins.socialsharing.share(self.compartir["mensaje"], self.compartir["titulo"], self.compartir["imagen"]);
			modal.show($("div.compartir-dialog").html(),true);
			e.preventDefault();
		});

		
		$("#modal").on("click","div.compartir-modal a.facebook",function(event){

			var fbDialog = "https://www.facebook.com/dialog/feed?app_id=1377982829129309" 
			+ "&link=" +encodeURIComponent("http://www.srcayetano.com")
			+ "&name="+encodeURIComponent(self.compartir["titulo"])
			+ "&description="+encodeURIComponent(self.compartir["mensaje"])
			+ "&picture="+encodeURIComponent(self.compartir["imagen"])
			+ "&redirect_uri=" +encodeURIComponent("http://www.srcayetano.com");

			var ref = window.open(fbDialog, '_system', 'location=yes');

			ref.addEventListener('loadstart', function(event) {

			});
			ref.addEventListener('loadstop', function(event) {
			     var post_id = event.url.split("post_id=")[1];
			     var cancel_url = event.url.split("#")[0];
			     if(post_id != undefined){
			            setTimeout(function() {
			                ref.close();                    
			            }, 5000);
			     }
			     if(cancel_url != undefined && cancel_url == your_redirect_uri){
			            setTimeout(function() {
			                ref.close();                        
			            }, 1000);
			     }                         
			});
			ref.addEventListener('exit', function(event) {

			}); 
			event.preventDefault();
		});

		$("#modal").on("click","div.compartir-modal a.twitter",function(event){
			var tweeter_url = 'https://twitter.com/intent/tweet?source=webclient&text='+encodeURIComponent(self.compartir["mensaje"]+ " vía @srcayetano") ;

			var ref = window.open(tweeter_url, '_system', 'location=yes');
			ref.addEventListener('loadstart', function(event) {

			} );
			ref.addEventListener('loadstop', function(event) {

			     if(event.url == 'https://mobile.twitter.com/'){

			         setTimeout(function() {
			                    ref.close();
			         }, 1000);
			     }

			} );
			ref.addEventListener('exit', function(event) {
			} );

			event.preventDefault();
		});
		
		self.$("a.miespacio").on("click",function(e){
			e.preventDefault();

			if (vars.login["logueado"] == false){
				location.hash = "#login";				
			}
			else{
					estado = (!self.$("a.miespacio").hasClass("activo"))?"activo":"desactivado";
					if(estado=="desactivado"){
						mensaje = "¿Estas seguro que deseas eliminarlo de tus planes?";
						botones = "Eliminar,Cancelar";
					}
					else{
						mensaje = "¿Estás seguro que deseas añadirlo a tus planes?";
						botones = "Añadir,Cancelar";
					}
					
					navigator.notification.confirm(
						mensaje,  // message
						function(boton){
							if(boton == 1){
								self.$("a.miespacio").addClass("cargando");
								
								$.ajax({
									type: "POST",
									url: url_datos + "anadiraplanes",
									data: {
										hash: vars.login["hash"],
										id_turismo: self.data.id,
										estado: estado
									},
									success:function(result){
										var obj = JSON.parse(result);
										
										if (typeof(obj.estado) != "undefined" && obj.estado == "activo"){
											self.$("a.miespacio").removeClass("cargando");
											self.$("a.miespacio").addClass("activo");
											/*navigator.notification.alert(
												'Añadido a tus planes!',  // message
												function(){},  			  // callback
												'Mis planes',            // title
												'Ok'                     // buttonName
											);*/
											
											$("#especial-anadido-planes").height(52);
											setTimeout(function(){$("#especial-anadido-planes").height(0);},1000);

											
											
										}
										else{
											self.$("a.miespacio").removeClass("cargando");
											self.$("a.miespacio").removeClass("activo");
										}
				
									}
								});
							}
							
						},              // callback to invoke with index of button pressed
						'Mis planes',            // title
						botones       // buttonLabels
					);
			}
				
				
			
			e.preventDefault();
		});
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goback();
    },
	clickpromo: function (event){
		vars.putSeccion($(event.currentTarget).find("span.titulo").html());
	},
	onClose: function(){
		clearInterval(self.intervaloCarrusel);
		self.intervaloCarrusel = null;
	}
  });
  // Our module now returns our view
  return FichaView;
});