// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/HomeView.html',
  'hammer',
  'hammer_jquery',
  'vars'
], function($, _, Backbone, HomeViewTemplate, Hammer, Jqueryhammer, vars){ 
  HomeView = Backbone.View.extend({
	ciudad : 0,
	intervaloCarrusel: null,
	stopintervalo: false,
	events: {
	  'click div.listado a': 'click',
  	  'click a.back-button': 'goBack'
	},
    render: function(){
		var self = this;
		
		var data = {ciudad: this.ciudad,titulo: vars.ciudadNombre};
		var compiledTemplate = _.template( HomeViewTemplate, data );

		this.$el.html(compiledTemplate);
		if (localStorage.getItem('homeCache' + this.ciudad) !== null){
			self.rellenarDatos(localStorage.getItem('homeCache' + this.ciudad));
		}

		if (typeof(window.plugins) != "undefined"){
			if (typeof(window.plugins.GameThrive) != "undefined"){
				window.plugins.GameThrive.sendTag("ciudad", this.ciudad);
			}
		}


		this.$el.find("div.loading").show();
		
		
		$.ajax({
			type: "POST",
			url: url_datos + "/ciudad/"+ this.ciudad + "/home?l=" + language + "&h=" + localStorage.getItem("hash"),
			data: {
				gamethrive_regid: window.localStorage.getItem("gamethrive_regid"),
			},
			cache: vars.cacheActivo,
			success:function(result){
				localStorage.setItem('homeCache' + self.ciudad ,result)
				self.rellenarDatos(localStorage.getItem('homeCache' + self.ciudad));
			}
		});
		
				
        return this;
    },
	initialize: function(options) {
		this.ciudad = options.ciudad;	
    },
	rellenarDatos: function(result){
		var self = this;
		self.$el.find("div.loading").fadeOut("fast");

		var obj = JSON.parse(result);

		if (typeof(obj.planes) != "undefined" && obj.planes > 0){
			self.$("div.listado ul li.planescayetano a").append('<div class="numero"><span>'+obj.planes+'</span></div>');
		}

		if (typeof(obj.tiendas) != "undefined" && obj.tiendas > 0){
			self.$("div.listado ul li.quenecesitas a").append('<div class="numero"><span>'+obj.tiendas+'</span></div>');
		}

		if (typeof(obj.ofertas) != "undefined" && obj.ofertas > 0){
			self.$("div.listado ul li.promociones a").append('<div class="numero"><span>'+obj.ofertas+'</span></div>');
		}

		if (typeof(obj.guia) != "undefined" && obj.guia > 0){
			self.$("div.listado ul li.quevisitar a").append('<div class="numero"><span>'+obj.guia+'</span></div>');
		}

		if (typeof(obj.ademas) != "undefined" && obj.ademas > 0){
			self.$("div.listado ul li.yademas a").append('<div class="numero"><span>'+obj.ademas+'</span></div>');
		}

		self.$("div.tapas-home").hide();
		if (typeof(obj.rutatapa) != "undefined" && obj.rutatapa != ""){
			self.$("div.tapas-home img").attr("src", obj.rutatapa);
			self.$("div.tapas-home").show();

			localStorage.setItem('homeCache' + self.ciudad + 'rutatapasplash', obj.rutatapa_splash);
			localStorage.setItem('homeCache' + self.ciudad + 'rutatapaganadores', obj.rutatapa_ganador_publicar);
			localStorage.setItem('homeCache' + self.ciudad + 'rutatapanombre', obj.rutatapa_nombre);


		}


		
		if (typeof(obj.carrusel) != "undefined"){
			//self.$("div.listado ul li:eq(4) a").append('<div class="numero"><span>'+obj.ademas+'</span></div>');
			totalCarrusel = Object.keys(obj.carrusel).length;
			if (totalCarrusel > 0){
				self.$("div.carrusel div.items").html('')
				
				self.$("div.carrusel div.control").show().html('');
				
				$.each(obj.carrusel, function(index, value) {
					//console.log(value.titulo);
					
					if (value.link != ""){
						self.$("div.carrusel div.items").append('<div class="item"><a href="'+value.link+'" title="'+value.titulo+'"><img src="'+value.imagen+'" /></a></div>')
					}
					else{
						self.$("div.carrusel div.items").append('<div class="item"><img src="'+value.imagen+'" /></div>')
					}
					
					self.$("div.carrusel div.control").append('<span class=""></span>')
				}); 
				
				self.$("div.carrusel div.control span:eq(0)").addClass('select')
			}
			
			
			
			
			
			if (totalCarrusel > 1){
				var hammertime = this.$("div.carrusel div.item").hammer();
				self.stopintervalo = false;
				this.$("div.carrusel div.item").css("left","100%");
				this.$("div.carrusel div.item:eq(0)").css("left","0");
				
				
				hammertime.on("swipeleft", function(ev) {
					ev.preventDefault();
					
					proximo = $(this).next();
					
					if (proximo.length <= 0){
						proximo = $(this).parent().find("div.item:eq(0)");
					}
					
					if (!$(this).is(":animated") && !proximo.is(":animated") ){
						$(this).animate({left:"-100%"});
						self.$("div.carrusel div.control span.select").removeClass("select");
						self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
						
						proximo.css({left:"100%"}).show();
						proximo.animate({left:0});
						
						self.stopintervalo = true;
					}
				});
				hammertime.on("swiperight", function(ev) {
					ev.preventDefault();
					proximo = $(this).prev();
					
					
					if (proximo.length <= 0){
						proximo = $(this).parent().find("div.item:last-child");
					}
					
					if (!$(this).is(":animated") && !proximo.is(":animated") ){
						$(this).animate({left:"100%"});
						self.$("div.carrusel div.control span.select").removeClass("select");
						self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
						
						proximo.css({left:"-100%"}).show();
						proximo.animate({left:0});
			
						self.stopintervalo = true;
					}

				});
				
				/*this.$("div.carrusel div.item").on("touchmove",function(e){e.preventDefault()});*/
				this.$("div.carrusel a").on("click",function(){
					url = $(event.currentTarget).attr("href");

					if (url.indexOf("http://") == 0){
						event.preventDefault();
						window.open(decodeURIComponent($(event.currentTarget).attr("href")),'_system','location=yes');
					}
					else{ 
						if (url != ""){
							vars.putSeccion($(this).attr("title"));
						}
						else{
							event.preventDefault();
						}
					}
				});
			
			
			
				this.$(".scroller").on("scroll",function(e){self.stopintervalo = true;});
			
				clearInterval(self.intervaloCarrusel);
				
				self.intervaloCarrusel = setInterval(self.functionCarrusel ,3000);
				
				self.functionCarrusel = function(){
					if (!self.stopintervalo){
						totalcarrusel = self.$("div.carrusel div.control span").length;
						if (totalcarrusel > 1){
							indexActual = self.$("div.carrusel div.control span.select").index();
							
							itemActual = self.$("div.carrusel div.item:eq("+indexActual+")");
							
							
							
							itemActual.animate({left:"-100%"});
							
							proximo = itemActual.next();
							
							if (proximo.length <= 0){
								proximo = itemActual.parent().find("div.item:eq(0)");
							}
							
							self.$("div.carrusel div.control span.select").removeClass("select");
							self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
				
							
							proximo.css({left:"100%"}).show();
							proximo.animate({left:0});
								
						}
					}
					else{
						self.stopintervalo = false;
					}
				}

			}
			
			
			
		}
},
	goBack: function(e) {
		e.preventDefault();
		vars.goback();
    },
	click: function(event) {
		vars.putSeccion($(event.currentTarget).find("span.titulo").html());
    },
	onClose: function(){
		clearInterval(self.intervaloCarrusel);
		self.intervaloCarrusel = null;
	}
  });
  // Our module now returns our view
  return HomeView;
});