define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/MapView.html',
  'models/ItemListado',
  'vars',
], function($, _, Backbone, MapViewTemplate, ItemListado, vars){
	
  HomeView = Backbone.View.extend({
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var self = this;
		
		this.idcanvas = Math.floor((Math.random()*100)+1);
		
		var data = {idcanvas: "googlemaps-" + this.idcanvas};
		var compiledTemplate = _.template( MapViewTemplate, data );

		this.$el.html(compiledTemplate);
		
		
		
		var total = vars.arrayLocalizacion.length;

		if (total > 0){
			$('#googlemaps-' + self.idcanvas).height($("div.scroller").height());
	
			require(
				['gmaps'],
				function(gmaps){
					var mapa = new GMaps({
					  div: '#googlemaps-' + self.idcanvas,
					  lat: 38.637053,
					  lng: -0.866388,
					  height: $("div.scroller").height() + "px"
					});
					var bound = new google.maps.LatLngBounds();
					
					for (i=0;i<total;i++){
						//console.log(vars.arrayLocalizacion[i]);
						latitud = parseFloat(vars.arrayLocalizacion[i][1].replace(",","."));
						longitud = parseFloat(vars.arrayLocalizacion[i][2].replace(",","."));
						nombre = vars.arrayLocalizacion[i][0];
						//console.log(latitud + "," + longitud);
						// Las añadimos a bound para centrar mejor el mapa
					 	bound.extend( new google.maps.LatLng(latitud, longitud) );
					
					
					
					
						mapa.addMarker({
							lat: latitud,
							lng: longitud,
							title: nombre,
							icon: "https://maps.gstatic.com/mapfiles/ms2/micons/green-dot.png",
							click: function(e){

							},
							infoWindow: {
								content: '<div class="infowindow"><p>'+nombre+'</p></div>'
							}
						});
					}
					
					if (vars.posicion.latitud != 0 && vars.posicion.longitud != 0){
						var tuposicion = new google.maps.LatLng(vars.posicion.latitud,vars.posicion.longitud);
						bound.extend( tuposicion );

						mapa.addMarker({
							lat: vars.posicion.latitud,
							lng: vars.posicion.longitud,
							title: 'test',
							icon: "https://maps.gstatic.com/mapfiles/ms2/micons/red-dot.png",
							infoWindow: {
								content: '<div class="infowindow"><p>Estas aquí</p></div>'
							}
						});
						
					}
					mapa.fitBounds(bound);

	
				}
			);





		}



        return this;
    },
	initialize: function(options) {
	    _.bindAll(this, 'render'); // every function that uses 'this' as the current object should be in here
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goback();
    },
	cargarMapa: function(e){
		
		
		
		
		
	}
  });
  // Our module now returns our view
  return HomeView;
});