// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/ficha/FichaView.html',
  'text!tpl/ficha/FichaNoticiasTexto.html',
  'models/ItemListado',
  'text!tpl/listado/ItemView.html',
  'socialsharing',
  'modal',
  'vars'
], function($, _, Backbone, FichaViewTemplate, FichaTexto, ItemListado, ItemViewTemp, socialsharing, modal, vars){


  FichaView = Backbone.View.extend({ 
    url : "",
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var data = {titulo : vars.getTituloActual()};
		var compiledTemplate = _.template( FichaViewTemplate, data );
		this.$el.html(compiledTemplate);
		
		var self = this;
		
//		console.log(vars.noticiasCache);
		var data = {};
		data.titulo = vars.noticiasCache[self.id].title;
		data.descripcion = '<p>'+vars.noticiasCache[self.id].description+'<br /><br /><a href="'+vars.noticiasCache[self.id].link+'" class="ver_noticia">Ver noticia completa</a></p>';
		data.direccion = "";
		data.codigopostal = "";
		data.poblacion = "";
		data.provincia = "";
		data.telefono = "";
		data.email = "";
		data.id = "";
		data.imagen = vars.noticiasCache[self.id].image;	
		
		
				
		self.compartir["mensaje"] = vars.noticiasCache[self.id].description;
		self.compartir["titulo"] = data.titulo;
		self.compartir["imagen"] = data.imagen;	
		
			  
		
		var compiledTemplate = _.template( FichaTexto, data );
		self.$el.find("div.contenido").hide().fadeIn().html(compiledTemplate);

		self.eventos();
		

        return this;
    },
	initialize: function(options) {
	     _.bindAll(this, 'render', 'eventos'); // every function that uses 'this' as the current object should be in here
		this.id = options.id;
		
		this.compartir = Array();
		this.compartir["mensaje"] = "";
		this.compartir["titulo"] = "";
		this.compartir["imagen"] = "";	

    },
	eventos: function(e) {
		var self = this;
		
		/*self.$("div.pestanas div.pestana").hide();
		self.$("div.pestanas div.pestana:eq(0)").show();
*/
		self.$("a.share").on("click",function(e){
			//window.plugins.socialsharing.share(self.compartir["mensaje"], self.compartir["titulo"], self.compartir["imagen"]);
			modal.show($("div.compartir-dialog").html(),true);
			e.preventDefault();
		});

		
		$("#modal").on("click","div.compartir-modal a.facebook",function(event){

			var fbDialog = "https://www.facebook.com/dialog/feed?app_id=1377982829129309" 
			+ "&link=" +encodeURIComponent("http://www.srcayetano.com")
			+ "&name="+encodeURIComponent(self.compartir["titulo"])
			+ "&description="+encodeURIComponent(self.compartir["mensaje"])
			+ "&picture="+encodeURIComponent(self.compartir["imagen"])
			+ "&redirect_uri=" +encodeURIComponent("http://www.srcayetano.com");

			var ref = window.open(fbDialog, '_system', 'location=yes');

			ref.addEventListener('loadstart', function(event) {

			});
			ref.addEventListener('loadstop', function(event) {
			     var post_id = event.url.split("post_id=")[1];
			     var cancel_url = event.url.split("#")[0];
			     if(post_id != undefined){
			            setTimeout(function() {
			                ref.close();                    
			            }, 5000);
			     }
			     if(cancel_url != undefined && cancel_url == your_redirect_uri){
			            setTimeout(function() {
			                ref.close();                        
			            }, 1000);
			     }                         
			});
			ref.addEventListener('exit', function(event) {

			}); 
			event.preventDefault();
		});

		$("#modal").on("click","div.compartir-modal a.twitter",function(event){
			var tweeter_url = 'https://twitter.com/intent/tweet?source=webclient&text='+encodeURIComponent(self.compartir["mensaje"]+ " vía @srcayetano") ;

			var ref = window.open(tweeter_url, '_system', 'location=yes');
			ref.addEventListener('loadstart', function(event) {

			} );
			ref.addEventListener('loadstop', function(event) {


			     if(event.url == 'https://mobile.twitter.com/'){

			         setTimeout(function() {
			                    ref.close();
			         }, 1000);
			     }

			} );
			ref.addEventListener('exit', function(event) {
			} );

			event.preventDefault();
		});


		self.$("div.cuerpo a:not(.telefono)").on("click",function(event){
			window.open($(event.currentTarget).attr("href"),'_system','location=yes');
			event.preventDefault();
		});

		
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goback();
    }
  });
  // Our module now returns our view
  return FichaView;
});