define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/listado/ListadoView.html',
  'text!tpl/listado/ItemView.html',
  'vars',
], function($, _, Backbone, ListadoTpl, ItemViewTemp, vars){
	
  HomeView = Backbone.View.extend({
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var self = this;
		
		var data = {titulo:this.titulo, ciudad:vars.ciudad, noback : false, css: "noticias"};
		var compiledTemplate = _.template( ListadoTpl, data );

		this.$el.html(compiledTemplate);
		self.$el.find("div.loading").hide();

		
		if (vars.noticiasCache.length == 0){
			self.$el.find("div.loading").show();
			$.get(self.rss, function(data) {
				var $xml = $(data);
				var contador = 0;
				aux = Array();
				
				$xml.find("item").each(function(i) {
					var $this = $(this),
						item = {
							title: $this.find("title").text(),
							link: $this.find("link").text(),
							description: $this.find("description").text(),
							pubDate: $this.find("pubDate").text(),
							image: $this.find("image").text(),
							author: $this.find("author").text()
						}
						
						
						
					if (typeof(item.image) == "undefined" || item.image == "" ){
						html = $.parseHTML( $this.find("description").text() ),
						item.image = $(html).find("img").attr("src");
						$(html).find("img").remove();
						
						item.description = $(html).text();
					}
						

					moment.lang("es");
					if (item.pubDate != ""){
						item.pubDate = vars.formatoFechas(item.pubDate);
					}
					
						
						
					aux.push(item);
					
				});
				
				self.rellenarDatos(aux);
				
				vars.noticiasCache = Array();
				vars.noticiasCache = aux;
			});
		}
		else{
			this.rellenarDatos(vars.noticiasCache);
			this.$("div.loading").fadeOut();
		}


        return this;
    },
	initialize: function(options) {
	    _.bindAll(this, 'render','rellenarDatos'); // every function that uses 'this' as the current object should be in here
		
		this.rss = options.rss;		
    },
	rellenarDatos: function(items){
		var self = this;

		
		totalitems = items.length;

		for(j=1;j<totalitems;j++){


			item = items[j];
			//console.log(item);
			var data = {link: "#ficha-noticia/"+ j,
						imagen: item.image,
						titulo: item.title,
						fechas: item.pubDate};
						
						
						
			var compiledTemplate = _.template( ItemViewTemp, data );
			
			self.$("ul").append("<li>"+compiledTemplate+"</li>");
		}

		self.$el.find("div.loading").fadeOut();
		
		self.$("img:not(.no-img)").hide().on("load",function(){$(this).parent().find("img.no-img").hide();$(this).fadeIn()});
		
		
		
		self.$("div.cuerpo a").on("click",function(event){
			window.open($(event.currentTarget).attr("href"),'_system','location=yes');
			event.preventDefault();
		});

		
	},
	goBack: function(e) {
		e.preventDefault();
		vars.goback();
    }
  });
  // Our module now returns our view
  return HomeView;
});