// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/PromocionesView.html',
  'vars',
  'views/listado/ListView'
], function($, _, Backbone, PromocionesTemp, vars, ListView){


  FichaView = Backbone.View.extend({ 
    url : "",
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){


		var data = {titulo : vars.getTituloActual(),noback : false,css:"promociones", seccion:this.seccion, ciudad : this.ciudad};
		var compiledTemplate = _.template( PromocionesTemp, data );
		this.$el.html(compiledTemplate);
		
		var self = this;
		
		var ciudad = this.ciudad;
		
		self.eventos();


		if (typeof(vars.seccionPromociones) != "undefined"){
			self.cargaseccion(vars.seccionPromociones);
			//delete vars.seccionPromociones;
		}
		else{
			self.cargaseccion(this.seccion);
		}
		
		
        return this;
    },
	initialize: function(options) {
	     _.bindAll(this, 'render', 'eventos'); // every function that uses 'this' as the current object should be in here
		this.seccion = options.seccion;
		this.ciudad = options.ciudad;

    },
	eventos: function(e) {
		var self = this;
		
		
		
		self.$el.find("div.nav-pestanas a").on("click",function(e){
			self.cargaseccion($(this).index());
			vars.seccionPromociones = $(this).index();
			e.preventDefault();
		});
		
		
		
		
    },
	cargaseccion: function(seccion){
		var self = this;
		self.$el.find("div.nav-pestanas a").removeClass("select");
		
		switch(seccion)
		{
		case 0:
			listview = new ListView({url:"ciudad/" + self.ciudad + "/ofertaspromociones", link:"#ficha-promocion/"});
			self.$el.find("div.listado").hide().fadeIn();
			self.$el.find("div.listado").addClass("promociones").removeClass("iconos");
			self.$el.find("div.listado").html(listview.render().$el);
			self.$el.find("div.nav-pestanas a:eq(0)").addClass("select");
		break;
		case 1:
			listview = new ListView({url:"ciudad/" + self.ciudad + "/ofertaspromocionesmasvistas", link:"#ficha-promocion/"});
			self.$el.find("div.listado").hide().fadeIn();
			self.$el.find("div.listado").addClass("promociones").removeClass("iconos");
			self.$el.find("div.listado").html(listview.render().$el);
			self.$el.find("div.nav-pestanas a:eq(1)").addClass("select");
		break;
		case 2:
			listview = new ListView({url:"ciudad/" + self.ciudad + "/ofertaspromocionesporsector", link:"#ciudad/"+self.ciudad+"/categoria-promociones/"});
			self.$el.find("div.listado").hide().fadeIn();
			self.$el.find("div.listado").addClass("iconos").removeClass("promociones");
			self.$el.find("div.listado").html(listview.render().$el);
			
			self.$el.find("div.nav-pestanas a:eq(2)").addClass("select");
		break;
		default:
			listview = new ListView({url:"ciudad/" + self.ciudad + "/ofertaspromociones", link:"#ficha-promocion/"});
			self.$el.find("div.listado").hide().fadeIn();
			self.$el.find("div.listado").addClass("promociones").removeClass("iconos");
			self.$el.find("div.listado").html(listview.render().$el);
			self.$el.find("div.nav-pestanas a:eq(0)").addClass("select");
		}
		
	},
	goBack: function(e) {
		vars.goback();
		delete vars.seccionPromociones;
    },
  });
  // Our module now returns our view
  return FichaView;
});