// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/tapas/TapasView.html',
  'vars',
  'views/listado/ListView'
], function($, _, Backbone, TapasView, vars, ListView){ 
  PlanesCayetano = Backbone.View.extend({
	ciudad : 0,
	events: {
	  'click a.back-button': 'goBack',
	  'click div.listado a': 'click'
	},
    render: function(){
		var self = this;
		

		titulo = "Ruta de la tapa";
		if (localStorage.getItem('homeCache' + self.ciudad + 'rutatapanombre') != null){
			titulo = localStorage.getItem('homeCache' + self.ciudad + 'rutatapanombre');
		}

		this.data =  {titulo: titulo ,ciudad: self.ciudad, logueado: vars.login["logueado"]};
		self.compiledTemplate = _.template( TapasView, this.data );
		self.$el.html(self.compiledTemplate);



		if (localStorage.getItem('homeCache' + self.ciudad + 'rutatapaganadores') != null && localStorage.getItem('homeCache' + self.ciudad + 'rutatapaganadores') == 1){
			self.$el.find("div.nav-pestanas a:eq(2)").html('<span class="icono icon-premio"></span>Ganadores');
		}
		else{
			self.$el.find("div.nav-pestanas a:eq(2)").html('<span class="icono icon-premio"></span>Premios');
		}


		if (localStorage.getItem('rutatapas_cache_menu_select') !== null){
			if (localStorage.getItem('rutatapas_cache_menu_select') == 2){
				self.$el.find("div.nav-pestanas a").removeClass("select");
				self.$el.find("div.nav-pestanas a:eq(1)").addClass("select");

				listview = new ListView({cache:false,url:"ciudad/" + self.ciudad + "/locales?l=" + language, link:"#ficha/"});
				self.$el.find("div.listado").html(listview.render().$el);


			}
			else if (localStorage.getItem('rutatapas_cache_menu_select') == 3){
				self.$el.find("div.nav-pestanas a").removeClass("select");
				self.$el.find("div.nav-pestanas a:eq(2)").addClass("select");

				$.ajax({
					type: "GET",
					url: url_datos + "/ciudad/"+ self.ciudad + "/tapas/ganadores?l=" + language + "&h=" + localStorage.getItem("hash"),
					cache: vars.cacheActivo,
					success:function(result){
						self.$el.find("div.listado").html('<div class="texto_premios">'+result+'</div>');
						self.$(".texto_premios").on("click","a",function(event){
							window.open($(event.currentTarget).attr("href"),'_system','location=yes');
							event.preventDefault();
						});

					}
				});

				self.$el.find("div.listado").html('<div class="loading"></div>');

			}
			else{
				self.$el.find("div.nav-pestanas a:eq(0)").addClass("select");

				listview = new ListView({cache:false, url:"ciudad/" + self.ciudad + "/tapas?l=" + language, link:"#ficha-tapa/"});
				self.$el.find("div.listado").hide().fadeIn();
				self.$el.find("div.listado").html(listview.render().$el);
			}
		}
		else{
			self.$el.find("div.nav-pestanas a:eq(0)").addClass("select");

			listview = new ListView({cache:false, url:"ciudad/" + self.ciudad + "/tapas?l=" + language, link:"#ficha-tapa/"});
			self.$el.find("div.listado").hide().fadeIn();
			self.$el.find("div.listado").html(listview.render().$el);
		}

		self.$el.find("div.nav-pestanas a.tapas").on("click",function(e){
			self.$el.find("div.nav-pestanas a").removeClass("select");
			$(this).addClass("select");

			listview = new ListView({cache:false, url:"ciudad/" + self.ciudad + "/tapas?l=" + language, link:"#ficha-tapa/"});
			self.$el.find("div.listado").html(listview.render().$el);

			localStorage.setItem('rutatapas_cache_menu_select',1);

			e.preventDefault();
		});


		self.$el.find("div.nav-pestanas a.locales").on("click",function(e){
			self.$el.find("div.nav-pestanas a").removeClass("select");
			$(this).addClass("select");

			listview = new ListView({cache:false, url:"ciudad/" + self.ciudad + "/locales?l=" + language, link:"#ficha/"});
			self.$el.find("div.listado").html(listview.render().$el);

			localStorage.setItem('rutatapas_cache_menu_select',2);

			e.preventDefault();
		});


		self.$el.find("div.nav-pestanas a.premios").on("click",function(e){
			self.$el.find("div.nav-pestanas a").removeClass("select");
			$(this).addClass("select");

			$.ajax({
				type: "GET",
				url: url_datos + "/ciudad/"+ self.ciudad + "/tapas/ganadores?l=" + language + "&h=" + localStorage.getItem("hash"),
				cache: vars.cacheActivo,
				success:function(result){
					self.$el.find("div.listado").html('<div class="texto_premios">'+result+'</div>');
					self.$(".texto_premios").on("click","a",function(event){
							window.open($(event.currentTarget).attr("href"),'_system','location=yes');
							event.preventDefault();
						});

				}
			});
			
			localStorage.setItem('rutatapas_cache_menu_select',3);

			//listview = new ListView({url:"ciudad/" + self.ciudad + "/ganadores", link:"#ficha-tapa/"});
			self.$el.find("div.listado").html('<div class="loading"></div>');

			e.preventDefault();
		});

        return this;
    },
	initialize: function(options) {
		this.ciudad = options.ciudad;
    },
	goBack: function(e) {
		e.preventDefault();
		localStorage.removeItem('rutatapas_cache_menu_select');
		vars.goback();
		vars.goback();

    },
	click: function(event) {
		//e.preventDefault();
		vars.putSeccion($(event.currentTarget).find("span.titulo").html());
    }
  });
  // Our module now returns our view
  return PlanesCayetano;
});