define([
  'jquery',
  'underscore',
  'backbone',
  'vars',
  'text!tpl/listado/ItemView.html',
  'text!tpl/listado/ItemViewTelefonos.html',
  'moment'
], function($, _, Backbone, vars, ItemViewTemp, ItemViewTelefonosTemp, moment){

  var ItemView = Backbone.View.extend({
    link : "",
    listadomisplanes : false,
    tagName: 'li',
    events: {
      'click': 'click'
    },
    initialize: function(options){
      _.bindAll(this, 'render'); // every function that uses 'this' as the current object should be in here
	  
	  this.link = options.link;
	  if (typeof(options.listadomisplanes) != "undefined")
		  this.listadomisplanes = options.listadomisplanes;
	  
    },
    render: function(){

		var self = this;
		linkstr = this.link + this.model.get('id')

		if (typeof(this.model.get('rss')) != "undefined" ){
			linkstr = this.link + encodeURIComponent(this.model.get('rss'));
		}
		
		var data = {link: linkstr ,
					id: this.model.get('id'),
					imagen: this.model.get('imagen'),
					titulo: this.model.get('nombre'),
					icono: this.model.get('icon'),
					numero: this.model.get('numero'),
					direccion: this.model.get('direccion'),
					telefono: this.model.get('telefono'),
					valido_hasta: this.model.get('valido_hasta'),
					gusta: this.model.get('log_gusta'),
					vistas: this.model.get('log_vistas'),
					nombre_empresa: this.model.get('nombre_comercio'),
					texto: this.model.get('texto'),
					ciudad_nombre: this.model.get('ciudad_nombre'),
					esarchivo: this.model.get('archivo'),
					votos: this.model.get('votos'),
		};
		
		if (self.listadomisplanes === true){
			data.listadomisplanes = true;
			data.listadomisplanes_tipo = "";

			if (this.link == "#ficha/"){
				data.listadomisplanes_tipo = "id_comercio";
			}
			else if(this.link == "#ficha-promocion/"){
				data.listadomisplanes_tipo = "id_promocion";
			}
			else if(this.link == "#ficha-evento/"){
				data.listadomisplanes_tipo = "id_promocion";
			}
			else if(this.link == "#ficha-quevisitar/"){
				data.listadomisplanes_tipo = "id_promocion";
			}
			else if(this.link == "#ficha-promocion/"){
				data.listadomisplanes_tipo = "id_promocion";
			}
			
			
			
			
			
			
			
		}
		else{
			data.listadomisplanes = false;
		}
		
		
		delete data.distancia;
		
		
		
		if (typeof(data.direccion) != "undefined"  )
		{
			data.datoscontacto = "";
			if (typeof(data.direccion) != "undefined"){
				data.datoscontacto = "<span>"+data.direccion+"</span>";
			}			
		}


		if (typeof(this.model.get('valido_hasta')) != "undefined")
		{


			data.valido_hasta = "Válido hasta " + moment(this.model.get('valido_hasta')).format("L");


			var d1 = new Date();
			var d2 = new Date(this.model.get('valido_hasta'));
			var diasfaltan = vars.DateDiff.inDays(d1, d2);

			if (diasfaltan < 5){
				if (diasfaltan > 1){
					data.valido_hasta = "Caduca en " + diasfaltan + " dias";
				}
				else if (diasfaltan == 1){
					data.valido_hasta = "Caduca en " + diasfaltan + " día";
				}
				
				data.resaltarfecha = true;
			}
			
			
		}
		else{
			if (typeof(this.model.get('fecha_inicio')) != "undefined"){
				//console.log(this.model.get('fecha_inicio') + "  " + this.model.get('fecha_fin'));
				data.fechas = vars.formatoFechas(this.model.get('fecha_inicio'),this.model.get('fecha_fin'));
			}
	
		}

		
				
		if (typeof(this.model.get('latitud')) != "undefined" && typeof(this.model.get('longitud')) != "undefined" ){
			if (this.model.get('latitud') != 0 && this.model.get('longitud') != 0 && this.model.get('latitud') != "" && this.model.get('longitud') != ""){
				data.distancia = vars.Distancia(this.model.get('latitud'),this.model.get('longitud'));
			}
			
		}
		
		this.data = data;


		if (typeof(this.model.get('tipo_listado')) != "undefined"){
			if (this.model.get('tipo_listado') == "telefonos-interes"){
				var compiledTemplate = _.template( ItemViewTelefonosTemp, data );
			}
			else{
				var compiledTemplate = _.template( ItemViewTemp, data );
			}
		}
		else{
			var compiledTemplate = _.template( ItemViewTemp, data );
		}
		
		

		this.$el.html(compiledTemplate);
		if (typeof(data.esarchivo) != "undefined" && data.esarchivo !== "1" ){
			this.$el.addClass("archivado");
		}
		
		this.$("img.no-img").hide();
		
		this.$("img:not(.no-img)").hide().on("load",function(){$(this).fadeIn()});
		this.$("img:not(.no-img)").hide().on("error",function(){$(this).parent().find("img.no-img").fadeIn();});
		
		if(data.listadomisplanes === true){
			this.$("span.eliminar-plan").on("click",function(e){
				
					e.stopImmediatePropagation();
					e.stopPropagation();
					e.preventDefault();
			
					mensaje = "¿Estas seguro que deseas eliminarlo de tus planes?";
					botones = "Eliminar,Cancelar";
					
					navigator.notification.confirm(
						mensaje,  // message
						function(boton){
							if(boton == 1){
								self.$("a.miespacio").addClass("cargando");
								
								var data = {};
								data["hash"] = vars.login["hash"];
								data[self.data.listadomisplanes_tipo] = self.data.id;
								data["estado"] = "desactivado";
								
								
								$.ajax({
									type: "POST",
									url: url_datos + "anadiraplanes",
									data: data,
									success:function(result){
										var obj = JSON.parse(result);
										
										if (typeof(obj.estado) != "undefined" && obj.estado == "activo"){
											
										}
										else{
											vars.goback();
										}
				
									}
								});
							}
						},              // callback to invoke with index of button pressed
						'Mis planes',            // title
						botones       // buttonLabels
					);

			
			});
		}		
		

		//$(this.$el).html('<a href="'+this.link + this.model.get('id')+'"><img src="'+this.model.get('imagen')+'" /><span class="titulo">'+this.model.get('nombre')+'</span></a>');
		return this; // for chainable calls, like .render().el
    },	
  });

    // Our module now returns our view
  return ItemView;
});
