// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'models/ItemListado',
  'collections/ListaCollection',
  'views/listado/ItemView',
  'tinyscrollbar',
  'vars',
  'backbone_fetch_cache'
], function($, _, Backbone, Item, List, ItemView,tinyscrollbar, vars,backbone_fetch_cache){

  // Because the new features (swap and delete) are intrinsic to each `Item`, there is no need to modify `ListView`.
  var ListView = Backbone.View.extend({
   events: {
	   'click ul li a' : 'click'
    },
    initialize: function(options){
	
      _.bindAll(this, 'render', 'appendItem', "click", "successCallback"); // every function that uses 'this' as the current object should be in here
	  var self = this;
	  
	  if (typeof(options.cache) != "undefined"){
		  this.cache = options.cache;
	  }
	  else{
		  this.cache = vars.cacheActivo;
	  }

	  if (typeof(options.externo) != "undefined"){
		  this.externo = options.externo;
	  }


	  this.css = "";
	  if (typeof(options.css) != "undefined"){
		  this.css = options.css;
	  }
	  
	  this.listadomisplanes = false;
	  if (typeof(options.listadomisplanes) != "undefined"){
		  this.listadomisplanes = options.listadomisplanes;
	  }
	  
	  
	  
	  
	  

      this.collection = new List();
	  
	  
	  if(options.url.indexOf("?") > -1){
		  this.collection.url = url_datos + options.url + "&l=" + language;
	  }
	  else{
		  this.collection.url = url_datos + options.url + "?l=" + language;
	  }
	  
	  

	  this.link = options.link;
	  self.contador = 0;
	  self.total = 0;
	  
	  self.arrayLocalizacion = Array();
	  vars.arrayLocalizacion = Array();
	  
	  
	  self.arrayTipoEventos = Array();
	  self.arrayTipoEventosId = Array();

      this.collection.bind('add', this.appendItem); // collection event binder
	  this.collection.fetch({prefill:this.cache, prefillSuccess:function(){}/*self.successCallback*/,success: self.successCallback,error: function(collection, response, options){
			if (vars.online == false){
				self.$el.find("div.loading").hide();
				
				self.$el.append('<p class="no_results">Necesitas estar conectado a internet para obtener los datos.</p>');
			}
		}
		});
  
    },
	successCallback: function(test){
	  	var self = this;

	  		//alert(self.link);


			if (self.collection.length == 0){
				self.mostrarSinResultado();
			}
			else{
				self.contador = 0;
				self.total = self.collection.length;

				if (self.css == "ciudades"){

					aux = new Object();
					for (i = 0;i< self.collection.models.length;i++){
						aux[self.collection.models[i].attributes.id] = self.collection.models[i].attributes.nombre;
					}
					console.log(aux);
					localStorage.setItem("ciudades_cache",JSON.stringify(aux));


				}


				// Almacenamos todas las latitudes y lognitudes si las hay para generar el mapa con todos los puntos
				self.collection.each(function(model){
					latitud = model.get("latitud");
					longitud = model.get("longitud");
					
					if (typeof(latitud) != "undefined" && typeof(longitud) != "undefined" && latitud != "" && longitud != ""){
						if (latitud != 0 && longitud != 0 && latitud != "" && longitud != ""){
							
							// Si tiene votos ( Si es una tapa ), el nombre que guarde debera ser el del comercio
							votos = model.get("votos");
							if (typeof(votos) != "undefined" ){
								self.arrayLocalizacion.push(Array(model.get("nombre_comercio"), latitud, longitud));
							}
							else{
								self.arrayLocalizacion.push(Array(model.get("nombre"), latitud, longitud));
							}
						}
					}
					// Filtro listado eventos 
					if (typeof(model.get("nombre_comercio")) != "undefined"){
						self.arrayTipoEventos.push(model.get("nombre_comercio"));
						self.arrayTipoEventosId.push(model.get("id_tipo"));
					}
				},this);
				

				if (self.arrayLocalizacion.length > 0){
					vars.arrayLocalizacion = self.arrayLocalizacion;
					self.$el.prepend('<a href="#mapa-grupo" class="ver_mapa"><span class="icono icon-localizacion"></span>Ver en mapa</a>');
				}
				
				// Boton mostrar archivados
				if (self.$el.find("li.archivado").length > 0){
					$('<a href="" class="verarchivados">Ver archivados</a>').insertBefore(self.$el.find("li.archivado").first());
					
					self.$el.find("a.verarchivados").on("click",function(e){
						self.$el.find("li.archivado").show();
						e.preventDefault();
					});
				}

				if (self.arrayTipoEventos.length >= 1 && self.css == "eventos"){

					self.arrayTipoEventos = $.unique(self.arrayTipoEventos);
					self.arrayTipoEventosId = $.unique(self.arrayTipoEventosId);
					self.$el.prepend('<select class="eventos_select"><option value="">Todas las categorias</option></select>');					
					totaltipos = self.arrayTipoEventos.length;					
					//rellenamos el select
					for(j=0;j<totaltipos;j++){
						self.$("select.eventos_select").append('<option value="'+self.arrayTipoEventosId[j]+'">'+self.arrayTipoEventos[j]+'</option>');
					}

					//controlamos el seleccionado
					if (typeof(vars.cacheeventoscategoria) != "undefined" && vars.cacheeventoscategoria != ""){
						self.$("select.eventos_select option[value='"+vars.cacheeventoscategoria+"']").prop('selected', true);
						self.$("select.eventos_select").val(self.$("select.eventos_select option[value='"+vars.cacheeventoscategoria+"']").val());

						if (vars.cacheeventoscategoria != ""){
							self.$("ul li").hide();
							self.$("p.nombre_empresa:contains("+self.$("select.eventos_select option[value='"+vars.cacheeventoscategoria+"']").html()+")").parent().parent().parent().show();
							console.log(self.$("p.nombre_empresa:contains("+self.$("select.eventos_select").val()+")").parent().html());
						}
						else{
							self.$("ul li").show();
						}						
					}
					
					self.$("select.eventos_select").on("change",function(){
						vars.cacheeventoscategoria = $(this).find("option:selected").attr("value");
						if ($(this).val() != 0){					
							self.$("ul li").hide();
							self.$("p.nombre_empresa:contains("+self.$("select.eventos_select option[value='"+vars.cacheeventoscategoria+"']").html()+")").parent().parent().parent().show();
						}
						else{
							self.$("ul li").show();
						}
					});
				}
			}
	},
    render: function(){
		this.$el.html('<div class="loading"></div><ul></ul>');

      return this;
    },
    appendItem: function(item){
	  if (this.contador == this.total){
		  this.$el.find("div.loading").hide();
		  this.$el.find("ul").hide().fadeIn("fast");
	  }
	  else if (this.contador > this.total || this.total == 0){
		  this.$el.find("div.loading").hide();
		  this.$el.find("ul").show();
		  
	  }

      var itemView = new ItemView({
        model: item,
		link: this.link,
		listadomisplanes: this.listadomisplanes
      });
      $('ul', this.$el).append(itemView.render().$el);
	  
	  self.$('p.no_results').hide();
	  
	  this.contador++;
	  
    },
	click: function(event){
		if (!this.externo){
			vars.putSeccion($(event.currentTarget).find("span.titulo").html());
		}
		else{ 
			window.open(decodeURIComponent($(event.currentTarget).attr("href")),'_system','location=yes');
			event.preventDefault();
		}
	},
	mostrarSinResultado: function(){
		this.$el.find("ul").html("");
		this.$el.find("div.loading").hide();
		this.$el.append('<p class="no_results">Sin resultados</p>');
	}
  });


    // Our module now returns our view
  return ListView;
});
