// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'views/listado/ListView',
  'text!tpl/listado/ListadoView.html',
  'vars'
], function($, _, Backbone, ListView, ListadoViewTemp, vars){


  ListadoView = Backbone.View.extend({
    url : "",
    link : "",
    titulo : "Titulo",
    css : "",
	listadomisplanes: false,
    noback : false,
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var self = this;
		var data = {titulo: this.titulo, css: this.css,noback: this.noback};
		var compiledTemplate = _.template( ListadoViewTemp, data );

		this.$el.html(compiledTemplate);

		var listview = new ListView({url:this.url, link: this.link, externo: this.externo, css: this.css,listadomisplanes: this.listadomisplanes,cache: this.cache});
		this.$el.find("div.listado").html(listview.render().$el);
		if (this.colaboradores){
			this.$el.find("div.listado").after('<div class="logos fondo-negro"><img src="img/camara_alicante.png"><img class="europa" src="img/fondo-europa.png"><img class="ministerio" src="img/ministerio.png"></div>');
		}

		if (this.css == "iconos"){
			if (this.url.indexOf("ciudad/"+vars.ciudad+"/turismo") >= 0){
				this.$el.find("div.listado").append('<ul style="display:block;clear:none;float:none"><li class="donde-comer"><a href="#ciudad/'+vars.ciudad+'/baresyrestaurantes"><div class="imagen"><span class="icono icon-restaurantes" aria-hidden="true"></span></div><div class="texto"><span class="titulo">Dónde comer</span></div></a></li></ul>');

				this.$el.find("div.listado li.donde-comer a").on("click",function(){
					vars.putSeccion($(event.currentTarget).find("span.titulo").html());
				});


			}
		}
		else{
			this.$el.find("div.listado ul li").append("ERROR FATAL");
		}

		delete temporalciudad;

        return this;
    },
	initialize: function(options) {
	    _.bindAll(this, 'render'); // every function that uses 'this' as the current object should be in here

		this.url = options.url;
		this.link = options.link;
		this.titulo = options.titulo;
		this.css = options.css;


		
		if (typeof(options.noback) != "undefined")
			this.noback = options.noback;
			
		this.externo = false;
		if (typeof(options.externo) != "undefined")
			this.externo = options.externo;
			
		if (typeof(options.listadomisplanes) != "undefined")
			this.listadomisplanes = options.listadomisplanes;
			
		this.colaboradores = false;
		if (typeof(options.colaboradores) != "undefined")
			this.colaboradores = true;

		if (typeof(options.cache) != "undefined")
			this.cache = options.cache;
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goback();
    }
  });
  // Our module now returns our view
  return ListadoView;
});