/* Modulo router

Segun el hash,

 */
 var AppSlider;
define([
  'jquery',
  'underscore',
  'backbone',
  'pageslider',
  'vars',
  'modal',
  'slimscroll',
  'text!tpl/ConstruccionView.html',
], function($, _, Backbone, ps, vars, modal,slimscroll,ConstruccionView){
 
	var AppRouter = Backbone.Router.extend({
		routes: {
		  'ciudad/:id': 'ciudad',
		  'ciudad/:id/quenecesitas': 'quenecesitas',
		  'ciudad/:id/categoria/:id': 'categoria',
		  'ficha/:id': 'ficha',
		  'mapa/:id': 'mapa',
		  'ciudad/:id/ofertaspromociones': 'ofertaspromociones',
		  'ciudad/:id/ofertaspromocionesmasvistas': 'ofertaspromocionesmasvistas',
		  'ciudad/:id/ofertaspromocionesporsector': 'ofertaspromocionesporsector',
		  'ciudad/:id/categoria-promociones/:id': 'categoriapromociones',
		  'ficha-promocion/:id': 'ficha-promocion',
		  'ciudad/:id/quevisitar': 'quevisitar',
		  'ciudad/:id/quevisitar/:id': 'quevisitarcategoria',
		  'ficha-quevisitar/:id': 'quevisitarficha',
		  'mapa-turismo/:id': 'turismomapa',
		  'mapa-grupo': 'mapagrupo',
		  'ciudad/:id/yademas': 'yademas',
		  'info': 'info',
		  'info/:seccion': 'info',
		  'infoficha/:view': 'infoficha',
		  'cuenta/misdatos': 'misdatos',
		  'cuenta/misplanes': 'misplanes',
		  'cuenta/misplanes/comercios': 'misplanes_comercios',
		  'cuenta/misplanes/promociones': 'misplanes_promociones',
		  'cuenta/misplanes/eventos': 'misplanes_eventos',
		  'cuenta/misplanes/turismo': 'misplanes_turismo',
		  'cuenta/misfavoritos': 'misfavoritos',
		  'cuenta/salircuenta': 'salircuenta',
		  'buscar': 'buscar',
		  'login': 'login',
		  'login/:seccion': 'login',
		  'miespacio': 'miespacio',
		  'micuenta': 'micuenta',
		  'camara': 'camara',
		  'ciudad/:id/planes': 'planes',
		  'ciudad/:id/planes/tiendas': 'planesTiendas',
		  'ciudad/:id/planes/ofertas': 'planesOfertas',
		  'ciudad/:id/planes/lugares': 'planesLugares',
		  'ciudad/:id/planes/eventos': 'planesEventos',
		  'ciudad/:id/eventos/:fecha': 'eventosListado',
		  'ciudad/:id/eventos': 'eventos',
		  'ficha-evento/:id': 'fichaEventos',
		  'ciudad/:id/noticias': 'noticias',
		  'listado-noticias/:rss': 'listadoNoticias',
		  'ficha-noticia/:id': 'fichaNoticia',
		  'ficha-radio/:url': 'fichaRadio',
		  'ciudad/:id/radio': 'radio',
		  'ciudad/:id/cine': 'cine',
		  // Default
		  '': 'defaultAction'
		}
	  });

  var initialize = function(){


	$(document).on('click','a[href="#info"]',function(e){
		//e.preventDefault();
		vars.putSeccion("Información");
	});

    var app_router = new AppRouter;
	AppSlider = new PageSlider($('#container'));
	
	
	modal.initialize();
	// Marca para saber si la pestaña promociones está abierta
	var PromocionesViewElemento = false;
	vars.initLogin();
	
	
    app_router.on('route:defaultAction', function(actions){
		console.log("### Entrando a ciudades ###");
		
		
		PromocionesViewElemento = false;
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){

				var plantilla = new ListadoView({css:"ciudades", noback:true, titulo:'<span class="icono icon-cayetano"></span>Sr. Cayetano', url:"ciudades", link : "#ciudad/"});
				AppSlider.slidePage(plantilla.render().$el);
				delete vars.planesCache;
				delete vars.homeCache;
				delete vars.noticiasCache;
            }
        );

		
		
		
		
		$("footer").hide();
    });
	
	
    app_router.on('route:quenecesitas', function(ciudadId){
		$("footer").show();
		PromocionesViewElemento = false;
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({css:"iconos", titulo:"Tiendas y restaurantes", url:"ciudad/" + ciudadId + "/empresastipo", link : "#ciudad/"+ciudadId+"/categoria/"});
				AppSlider.slidePage(plantilla.render().$el);

            }
        );

		
    });
	
    app_router.on('route:categoria', function(ciudadId, categoriaId){
		$("footer").show();
		PromocionesViewElemento = false;
		
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/categoria/" + categoriaId, link : "#ficha/"});
				AppSlider.slidePage(plantilla.render().$el);

            }
        );

		
		
		
    });
	
    app_router.on('route:ficha', function(fichaId){
		$("footer").show();
		PromocionesViewElemento = false;
		
        require(
            ['views/FichaView'],
            function(FichaView){
				$("footer").show();
				var plantilla = new FichaView({titulo: vars.tituloClick ,url: 'empresa/' + fichaId});
				AppSlider.slidePage(plantilla.render().$el);
				
				//touchscroll.reload();
            }
        );
		
		
    });


    app_router.on('route:ciudad', function(ciudadId){
		PromocionesViewElemento = false;

        require(
            ['views/HomeView'],
            function(HomeView){
				$("footer").show();
				var plantilla = new HomeView({ciudad:ciudadId});
				AppSlider.slidePage(plantilla.render().$el);
				
				//$("div.page-center div.scroller").css('top',((parseInt(self.$("div.carrusel").css("padding-bottom")) + 46) + "px"));

				
				//touchscroll.reload();
            }
        );


		vars.ciudad = ciudadId;
		vars.ciudadNombre = vars.getTituloActual();
		localStorage.setItem("ciudad",ciudadId)
		localStorage.setItem("ciudadnombre",vars.getTituloActual());

		
    });

    app_router.on('route:planes', function(ciudadId){
		PromocionesViewElemento = false;

        require(
            ['views/PlanesView'],
            function(PlanesView){
				$("footer").show();
				var plantilla = new PlanesView({ciudad:ciudadId});
				AppSlider.slidePage(plantilla.render().$el);
				
            }
        );

		
    });

    app_router.on('route:planesTiendas', function(ciudadId){
		$("footer").show();
		PromocionesViewElemento = false;
		
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){

				var plantilla = new ListadoView({titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/planes/tiendas", link : "#ficha/"});
				AppSlider.slidePage(plantilla.render().$el);

            }
        );


    });
	
    app_router.on('route:planesOfertas', function(ciudadId){
		$("footer").show();
		PromocionesViewElemento = false;		
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({css:"promociones", titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/planes/ofertas", link : "#ficha-promocion/"});
				AppSlider.slidePage(plantilla.render().$el);

            }
        );
		
		
		
		

    });
	
    app_router.on('route:planesLugares', function(ciudadId){
		$("footer").show();
		
		PromocionesViewElemento = false;
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/planes/lugares", link : "#ficha-quevisitar/"});
				AppSlider.slidePage(plantilla.render().$el);

            }
        );


    });
	
	
    app_router.on('route:planesEventos', function(ciudadId){
		$("footer").show();
		
		PromocionesViewElemento = false;
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/planes/eventos", link : "#ficha-evento/"});
				AppSlider.slidePage(plantilla.render().$el);

            }
        );


    });
	
	
	
	
    app_router.on('route:eventos', function(){
		PromocionesViewElemento = false;
        require(
            ['views/EventosView'],
            function(EventosView){
				$("footer").hide();
				
				var plantilla = new EventosView();
				AppSlider.slidePage(plantilla.render().$el);
            }
        );

		
		
    });
    app_router.on('route:eventosListado', function(ciudad,fecha){
		PromocionesViewElemento = false;
        require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				$("footer").hide();
				
				var plantilla = new ListadoView({titulo: vars.getTituloActual() ,url:"ciudad/" + vars.ciudad + "/eventos/" + fecha, link : "#ficha-evento/", css: "eventos"});
				AppSlider.slidePage(plantilla.render().$el);
            }
        );

		
		
    });
	
    app_router.on('route:fichaEventos', function(fichaId){
		$("footer").show();
		
		PromocionesViewElemento = false;
		require(
            ['views/FichaEventosView'],
            function(FichaEventosView){
				var plantilla = new FichaEventosView({titulo: vars.tituloClick ,url: 'evento/' + fichaId});
				AppSlider.slidePage(plantilla.render().$el);
            }
        );


		
		
    });

	
    app_router.on('route:noticias', function(){
		PromocionesViewElemento = false;
        require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				$("footer").show();
				vars.noticiasCache = Array();
				var plantilla = new ListadoView({titulo: vars.getTituloActual(), url:"ciudad/" + vars.ciudad + "/noticias", link : "#listado-noticias/", css: "eventos"});
				AppSlider.slidePage(plantilla.render().$el);
            }
        );
    });
	
    app_router.on('route:listadoNoticias', function(rss){
		PromocionesViewElemento = false;
        require(
            ['views/NoticiasView'],
            function(NoticiasView){
				$("footer").show();

				var plantilla = new NoticiasView({titulo: vars.getTituloActual(), rss: rss});
				AppSlider.slidePage(plantilla.render().$el);
            }
        );
    });
	
	
    app_router.on('route:fichaNoticia', function(id){
		
		PromocionesViewElemento = false;
        require(
            ['views/NoticiasFichaView'],
            function(NoticiasFichaView){
				$("footer").show();

				var plantilla = new NoticiasFichaView({titulo: vars.getTituloActual(),id : id});
				AppSlider.slidePage(plantilla.render().$el);
            }
        );
    });
    app_router.on('route:fichaRadio', function(url){
		
		PromocionesViewElemento = false;
        require(
            ['views/RadioFichaView'],
            function(RadioFichaView){
				$("footer").show();

				var plantilla = new RadioFichaView({url: url});
				AppSlider.slidePage(plantilla.render().$el);
            }
        );
    });
	
	
	
	
	
	
    app_router.on('route:cine', function(){
		PromocionesViewElemento = false;
        require(
            ['views/CineView'],
            function(CineView){
				$("footer").hide();
				
				var plantilla = new CineView();
				AppSlider.slidePage(plantilla.render().$el);
            }
        );

		
		
    });
	
    app_router.on('route:radio', function(){
		PromocionesViewElemento = false;
		plataforma = device.platform;
		
        require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				$("footer").show();
				if (plataforma == "iOS"){
					var plantilla = new ListadoView({titulo: vars.getTituloActual(), url:"ciudad/" + vars.ciudad + "/radios", link : "", css: "eventos", externo: true});
				}
				else{
					var plantilla = new ListadoView({titulo: vars.getTituloActual(), url:"ciudad/" + vars.ciudad + "/radios", link : "#ficha-radio/", css: "eventos"});
				}
					
				AppSlider.slidePage( plantilla.render().$el);
				
				
            }
        );
    });
	
	
    app_router.on('route:mapa', function(comercioId){
		PromocionesViewElemento = false;
        require(
            ['views/MapView'],
            function(MapView){
				$("footer").hide();
				
				var plantilla = new MapView({url: 'empresa-mapa/' + comercioId});
				AppSlider.slidePage(plantilla.render().$el);
            }
        );

		
		
    });
    app_router.on('route:mapagrupo', function(comercioId){
		PromocionesViewElemento = false;
        require(
            ['views/MapGrupoView'],
            function(MapGrupoView){
				$("footer").hide();
				vars.putSeccion("Mapa");
				
				var plantilla = new MapGrupoView();
				AppSlider.slidePage(plantilla.render().$el);
            }
        );

		
		
    });
	
	
	
	
	var mostrarLogin = function(seccion){

		if (vars.login["logueado"] == true){
			mostrarCuenta();
		}
		else{
		
			$("footer").hide();
			PromocionesViewElemento = false;
			require(
				['views/LoginView'],
				function(LoginView){				
					var plantilla = new LoginView({seccion:seccion});
					modal.show(plantilla.render().$el);
					//AppSlider.saveHistory();
	
				}
			);

		}
    }
	
    app_router.on('route:login', mostrarLogin);	
	var mostrarCuenta = function(){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			vars.putSeccion("Mi cuenta");
			$("footer").hide();
			PromocionesViewElemento = false;
	
			require(
				['views/InformacionView'],
				function(InformacionView){
					var plantilla = new InformacionView({ciudad:vars.ciudad, seccion: "cuenta"});
					AppSlider.slidePage(plantilla.render().$el);

				}
			);
			
			
			
		}
		
    }
	
    app_router.on('route:micuenta', mostrarCuenta);
    app_router.on('route:info', function(seccion){
		$("footer").hide();
		PromocionesViewElemento = false;

        require(
            ['views/InformacionView'],
            function(InformacionView){
				var plantilla = new InformacionView({ciudad:vars.ciudad, seccion: seccion});
				AppSlider.slidePage(plantilla.render().$el);
				
            }
        );

    });
	
	
    app_router.on('route:buscar', function(){
			$("footer").hide();
			
			PromocionesViewElemento = false;
			
			require(
				['views/BuscarView'],
				function(BuscarView){				
					var plantilla = new BuscarView();
					AppSlider.slidePage(plantilla.render().$el);
	
				}
			);

		
    });

	
	
    app_router.on('route:infoficha', function(view){
		$("footer").hide();
		PromocionesViewElemento = false;

        require(
            ['views/InformacionFichaView'],
            function(InformacionFichaView){
				$("footer").hide();
				var plantilla = new InformacionFichaView({ciudad:vars.ciudad, view: view});
				AppSlider.slidePage(plantilla.render().$el);
				
            }
        );

    });
	
    app_router.on('route:categoriapromociones', function(ciudadId, categoriaId){
		$("footer").show();
		PromocionesViewElemento = false;
		
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({css:'promociones',titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/categoria-promociones/" + categoriaId, link : "#ficha-promocion/"});
				AppSlider.slidePage(plantilla.render().$el);

            }
        );

		
		
		
    });
	
    app_router.on('route:ofertaspromociones', function(ciudadId){
		$("footer").show();
				
		require(
            ['views/PromocionesView'],
            function(PromocionesView){
				if (PromocionesViewElemento == false){
					PromocionesViewElemento = new PromocionesView({css:"promociones", titulo: vars.getTituloActual(), link : "#ficha-promocion/", ciudad:ciudadId, seccion:0});
					AppSlider.slidePage(PromocionesViewElemento.render().$el);
				}
				else{
					PromocionesViewElemento.cargaseccion(0);
					AppSlider.saveHistory();

				}
				
				
				$("div.page-center div.scroller").css('top',((parseInt(self.$("div.nav-pestanas").height()) + 46) + "px"));

            }
        );
		
		
		
		

    });
    app_router.on('route:ofertaspromocionesmasvistas', function(ciudadId){
		$("footer").show();
		
		require(
            ['views/PromocionesView'],
            function(PromocionesView){
				if (PromocionesViewElemento == false){
					PromocionesViewElemento = new PromocionesView({css:"promociones", titulo: vars.getTituloActual(), link : "#ficha-promocion/", ciudad:ciudadId, seccion:1});
					AppSlider.slidePage(PromocionesViewElemento.render().$el);
				}
				else{
					PromocionesViewElemento.cargaseccion(1);
					AppSlider.saveHistory();
				}
				
				$("div.page-center div.scroller").css('top',((parseInt(self.$("div.nav-pestanas").height()) + 46) + "px"));

            }
        );

    });
	
    app_router.on('route:ofertaspromocionesporsector', function(ciudadId){
		$("footer").show();
		
		require(
            ['views/PromocionesView'],
            function(PromocionesView){
				if (PromocionesViewElemento == false){
					PromocionesViewElemento = new PromocionesView({css:"iconos", titulo: vars.getTituloActual(), link : "#ficha-promocion/", ciudad:ciudadId, seccion:2});
					AppSlider.slidePage(PromocionesViewElemento.render().$el);
				}
				else{
					PromocionesViewElemento.cargaseccion(2);
					AppSlider.saveHistory();
				}
				
				$("div.page-center div.scroller").css('top',((parseInt(self.$("div.nav-pestanas").height()) + 46) + "px"));

				

            }
        );

    });
	
    app_router.on('route:ficha-promocion', function(fichaId){
		$("footer").show();
		
		PromocionesViewElemento = false;
		require(
            ['views/FichaPromocionView'],
            function(FichaPromocionView){
				var plantilla = new FichaPromocionView({titulo: vars.tituloClick ,url: 'promocion/' + fichaId});
				AppSlider.slidePage(plantilla.render().$el);

            }
        );
		

    });


    app_router.on('route:yademas', function(ciudadId){
		$("footer").show();
		PromocionesViewElemento = false;
		
		require(
            ['views/YademasView'],
            function(YademasView){
				var plantilla = new YademasView({titulo: vars.tituloClick});
				AppSlider.slidePage(plantilla.render().$el);
            }
        );
    });

    app_router.on('route:misplanes', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			vars.putSeccion("Mis planes");

			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/MisPlanesView'],
				function(MisPlanesView){
					var plantilla = new MisPlanesView({titulo: vars.tituloClick ,url: 'misplanes/'});
					AppSlider.slidePage(plantilla.render().$el);
					//$el.find("a.back-button").on("click",function(e){vars.goBack();});
	
				}
			);
			
			
		}
    });
    app_router.on('route:misplanes_comercios', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			vars.putSeccion("Mis planes");

			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/listado/ListadoView'],
				function(ListadoView){
					var plantilla = new ListadoView({css:"comercios", titulo:"Tiendas y restaurantes", url:"/planesusuario/comercios" + "?h=" + vars.login["hash"], link : "#ficha/"});
					AppSlider.slidePage(plantilla.render().$el);
	
				}
			);
			
		}
    });
    app_router.on('route:misplanes_promociones', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			vars.putSeccion("Mis planes");

			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/listado/ListadoView'],
				function(ListadoView){
					var plantilla = new ListadoView({css:"promociones", titulo:"Ofertas y cupones", url:"/planesusuario/promociones" + "?h=" + vars.login["hash"], link : "#ficha-promocion/"});
					AppSlider.slidePage(plantilla.render().$el);
	
				}
			);
			
		}
    });
    app_router.on('route:misplanes_eventos', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			vars.putSeccion("Mis planes");

			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/listado/ListadoView'],
				function(ListadoView){
					var plantilla = new ListadoView({css:"eventos", titulo:"Eventos", url:"/planesusuario/eventos" + "?h=" + vars.login["hash"], link : "#ficha-evento/"});
					AppSlider.slidePage(plantilla.render().$el);
	
				}
			);
			
		}
    });
    app_router.on('route:misplanes_turismo', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			vars.putSeccion("Mis planes");

			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/listado/ListadoView'],
				function(ListadoView){
					var plantilla = new ListadoView({css:"turismo", titulo:"Lugares de interés", url:"/planesusuario/turismo" + "?h=" + vars.login["hash"], link : "#ficha-quevisitar/"});
					AppSlider.slidePage(plantilla.render().$el);
	
				}
			);
			
		}
    });
	
    app_router.on('route:misdatos', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/MisDatosView'],
				function(MisDatosView){
					var plantilla = new MisDatosView({titulo: vars.tituloClick ,url: 'misplanes/'});
					AppSlider.slidePage(plantilla.render().$el);
					//$el.find("a.back-button").on("click",function(e){vars.goBack();});
	
				}
			);
			
			
		}
    });
	
	
	
	
	

    app_router.on('route:misfavoritos', function(ciudadId){
		if (vars.login["logueado"] == false){
			mostrarLogin();
		}
		else{
			$("footer").hide();
			PromocionesViewElemento = false;
			
			require(
				['views/MisFavoritosView'],
				function(MisFavoritosView){
					var plantilla = new MisFavoritosView({titulo: vars.tituloClick ,url: 'misfavoritos/'});
					AppSlider.slidePage(plantilla.render().$el);
					//$el.find("a.back-button").on("click",function(e){vars.goBack();});
	
				}
			);
			
			
		}
    });



    app_router.on('route:quevisitar', function(ciudadId){
		$("footer").show();
		PromocionesViewElemento = false;
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({css:"iconos", titulo:"Guia turística", url:"ciudad/" + ciudadId + "/turismo", link : "#ciudad/"+ciudadId+"/quevisitar/"});
				AppSlider.slidePage(plantilla.render().$el);

            }
        );

		
    });


    app_router.on('route:quevisitarcategoria', function(ciudadId, categoriaId){
		$("footer").show();
		
		PromocionesViewElemento = false;
		
		require(
            ['views/listado/ListadoView'],
            function(ListadoView){
				var plantilla = new ListadoView({titulo: vars.getTituloActual() ,url:"ciudad/" + ciudadId + "/turismo/" + categoriaId, link : "#ficha-quevisitar/"});
				AppSlider.slidePage(plantilla.render().$el);

            }
        );

		
    });

    app_router.on('route:quevisitarficha', function(fichaId){
		$("footer").show();
		
		PromocionesViewElemento = false;
				
		require(
            ['views/FichaTurismoView'],
            function(FichaTurismoView){
				var plantilla = new FichaTurismoView({titulo: vars.tituloClick ,url: 'turismo/' + fichaId});
				AppSlider.slidePage(plantilla.render().$el);
            }
        );
		
    });

	
    app_router.on('route:turismomapa', function(comercioId){
		
		PromocionesViewElemento = false;
		require(
            ['views/MapView'],
            function(MapView){
				$("footer").hide();
				var plantilla = new MapView({url: 'turismo/' + comercioId + "/mapa" });
				AppSlider.slidePage(plantilla.render().$el);
            }
        );
    });
    app_router.on('route:salircuenta', function(comercioId){
		
		PromocionesViewElemento = false;
		vars.salirCuenta();
    });

	
    Backbone.history.start();	
  };
  return {
    initialize: initialize
  };
});