define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/EventosView.html',
  'text!tpl/calendario/clndr-template.html',
  'vars',
  'clndr',
], function($, _, Backbone, EventosTpl, clndrTpl, vars, clndr){
	
  HomeView = Backbone.View.extend({
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var self = this;
		moment.lang("es");
		var data = {titulo:"Eventos",ciudad:vars.ciudad};
		var compiledTemplate = _.template( EventosTpl, data );

		this.$el.html(compiledTemplate);		
		
		
		$.ajax({
			type: "GET",
			url: url_datos + "ciudad/"+vars.ciudad+"/eventos",
			success:function(result){
				console.log(result);
				var obj = JSON.parse(result);
				self.$("div.loading").fadeOut();
				tamano = obj.length;
				
				var aux = Array();
				for(i=0;i<tamano;i++){
					//calendarioInstance
					aux.push({date:obj[i]});
				}
				self.calendarioInstance.setEvents(aux);
				
				
			}
		});

		
		
		
		// this will use clndr's default template, which you probably don't want.
		this.calendarioInstance = this.$("div.calendar").clndr({
			template: clndrTpl,
			weekOffset: 1,
			daysOfTheWeek: ['DO', 'LU', 'MA', 'MI', 'JU', 'VI', 'SA'],
			  constraints: {
				startDate: new Date()
			  },
			events: [
			/**{ date: '2014-01-16'},
			{ date: '2014-01-19'},
			{ date: '2014-01-22'},			
			{ date: '2014-01-26'},
			{ date: '2014-02-26'},
			{ date: '2014-03-26'},
			{ date: '2014-06-26'},*/
			],
			clickEvents: {
				click: function(target) {
				  if (target.events.length > 0){
					window.location.hash = "#ciudad/"+vars.ciudad+"/eventos/" + target.date._a[2]+"-"+(target.date._a[1]+1)+"-"+target.date._a[0];
					vars.putSeccion(target.date._a[2]+"/"+(target.date._a[1]+1)+"/"+target.date._a[0]);
				  }
				  
				}
			},
		});


        return this;
    },
	initialize: function(options) {
	    _.bindAll(this, 'render'); // every function that uses 'this' as the current object should be in here
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goBack();
    },
  });
  // Our module now returns our view
  return HomeView;
});