// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/ficha/FichaView.html',
  'text!tpl/ficha/FichaEventosTexto.html',
  'models/ItemListado',
  'text!tpl/listado/ItemView.html',
  'vars',
  'moment'
], function($, _, Backbone, FichaViewTemplate, FichaEventosTexto, ItemListado, ItemViewTemp, vars, moment){


  FichaView = Backbone.View.extend({ 
    url : "",
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var data = {titulo : vars.getTituloActual()};
		var compiledTemplate = _.template( FichaViewTemplate, data );
		this.$el.html(compiledTemplate);
		
		var self = this;
		
				
		
		var item = new ItemListado({url: url_datos + this.url + "?h=" + vars.login["hash"],template: FichaViewTemplate});

		item.fetch({cache:vars.cacheActivo, data: {},prefillSuccess:self.rellenarDatos, success: self.rellenarDatos});
		

        return this;
    },
	initialize: function(options) {
	     _.bindAll(this, 'render', 'eventos','rellenarDatos'); // every function that uses 'this' as the current object should be in here

		this.url = options.url;
		this.titulo = options.titulo;		
				//alert(vars.getTituloActual() + "asdfsdf");

		this.compartir = Array();
		this.compartir["mensaje"] = "";
		this.compartir["titulo"] = "";
		this.compartir["imagen"] = "";	
    },
	rellenarDatos: function(item){
		var self = this;
				if (typeof(item.attributes) == "undefined"){
					atributos = item;
				}
				else{
					atributos = item.attributes;
				}
				var data = {};
				data.titulo = atributos.nombre;
				data.descripcion = atributos.descripcion;
				data.direccion = atributos.direccion;
				data.codigopostal = atributos.cp;
				data.poblacion = atributos.poblacion;
				data.provincia = atributos.provincia;
				data.telefono = atributos.telefono;
				data.email = atributos.email;
				data.id = atributos.id;
				data.id_comercio = atributos.id_comercio;
				data.imagen = atributos.imagen;
				data.imagen_comercio = atributos.imagen_comercio;
				data.titulo_comercio = atributos.titulo_comercio;
				data.cupon = atributos.cupon;
				
				moment.lang("es");	
				data.fechaini = moment(atributos.fecha_inicio).format("LLL");

				if (atributos.fecha_fin != "0000-00-00 00:00:00")
					data.fechafin = moment(atributos.fecha_fin).format("LLL");



				data.misplanes = false;
				if (typeof(atributos.misplanes) != "undefined" && atributos.misplanes > 0)
					data.misplanes = true;
				
				data.megusta = false;
				if (typeof(atributos.megusta) != "undefined" && atributos.megusta > 0)
					data.megusta = true;
				
				// Calculamos cuanto queda para que finalize, si es en una semana mostraremos un mensaje.
				var d1 = new Date();
				var d2 = new Date(atributos.fecha_fin);
				var diasfaltan = vars.DateDiff.inDays(d1, d2);
				
				if (diasfaltan <= 7 && diasfaltan >= 0){
					data.ultimosDias = diasfaltan;
				}
				self.data = data;

				var compiledTemplate = _.template( FichaEventosTexto, data );
				
				//$("#container > div.page:last-child #ficha").html(compiledTemplate);
				//self.mostrarFicha(item);
				self.$el.find("div.contenido").html(compiledTemplate);				

				
				self.compartir["mensaje"] = data.descripcion + " " + data.direccion + " " + data.codigopostal + " "  + data.poblacion + " (" + data.provincia + ") Telf: " + data.telefono + " Email: " + data.email;
				self.compartir["titulo"] = data.titulo;
				self.compartir["imagen"] = data.imagen;	
				
				
				self.$el.find("div.carrusel img").on("error",function(){$(this).attr("src","img/ficha-noimg.jpg");$(this).css("top",0)});				

				self.eventos();
	
	},
	eventos: function(e) {
		var self = this;
		
		self.$("a.miespacio").on("click",function(e){
			if (vars.login["logueado"] == false){
				location.hash = "#login";				
			}
			else{
					estado = (!self.$("a.miespacio").hasClass("activo"))?"activo":"desactivado";
					if(estado=="desactivado"){
						mensaje = "¿Estas seguro que deseas eliminarlo de tus planes?";
						botones = "Eliminar,Cancelar";
					}
					else{
						mensaje = "¿Estás seguro que deseas añadirlo a tus planes?";
						botones = "Añadir,Cancelar";
					}
					
					/*navigator.notification.confirm(
						mensaje,  // message
						function(boton){
							if(boton == 1){*/
								self.$("a.miespacio").addClass("cargando");
								
								$.ajax({
									type: "POST",
									url: url_datos + "anadiraplanes",
									data: {
										hash: vars.login["hash"],
										id_evento: self.data.id,
										estado: estado
									},
									success:function(result){
										var obj = JSON.parse(result);
										
										if (typeof(obj.estado) != "undefined" && obj.estado == "activo"){
											self.$("a.miespacio").removeClass("cargando");
											self.$("a.miespacio").addClass("activo");
											/*navigator.notification.alert(
												'Añadido a tus planes!',  // message
												function(){},  			  // callback
												'Mis planes',            // title
												'Ok'                     // buttonName
											);*/
										}
										else{
											self.$("a.miespacio").removeClass("cargando");
											self.$("a.miespacio").removeClass("activo");
										}
				
									}
								});
							/*}
							
						},              // callback to invoke with index of button pressed
						'Mis planes',            // title
						botones       // buttonLabels
					);*/
				
			}			
			
			e.preventDefault();
		});
		self.$("a.megusta").on("click",function(e){
			if (vars.login["logueado"] == false){
				location.hash = "#login";				
			}
			else{
				self.$("a.megusta").addClass("cargando");
				estado = (!self.$("a.megusta").hasClass("activo"))?"activo":"desactivado";

				$.ajax({
					type: "POST",
					url: url_datos + "anadiramegusta",
					data: {
						hash: vars.login["hash"],
						id_evento: self.data.id,
						estado: estado,
					},
					success:function(result){
						var obj = JSON.parse(result);
						if (typeof(obj.estado) != "undefined" && obj.estado == "activo"){
							self.$("a.megusta").removeClass("cargando");
							self.$("a.megusta").addClass("activo");
						}
						else{
							self.$("a.megusta").removeClass("cargando");
							self.$("a.megusta").removeClass("activo");
						}
					}
				});
			}			
			e.preventDefault();
		});
		
		self.$("div.quiero-cupon a").on("click",function(e){
			if (vars.login["logueado"] == false){
				location.hash = "#login";				
			}
			else{
				self.$("div.quiero-cupon").addClass("cargando");
				
				$.ajax({
					type: "POST",
					url: url_datos + "canjearcupon",
					data: {
						hash: vars.login["hash"],
						id_promocion: self.data.id,
					},
					success:function(result){
						self.$("div.quiero-cupon a").html("tu código de cupón es: 5009892");
						/*self.$("a.miespacio").removeClass("cargando");
						self.$("a.miespacio").addClass("activo");*/
						console.log(result);
						var obj = JSON.parse(result);
					}
				});
				
			}			
			e.preventDefault();
		});
		
		self.$("a.share").on("click",function(e){
			window.plugins.socialsharing.share(self.compartir["mensaje"], self.compartir["titulo"], self.compartir["imagen"]);
			e.preventDefault();
		});
		
		
		
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goBack();
    },
  });
  // Our module now returns our view
  return FichaView;
});