// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/ficha/FichaView.html',
  'text!tpl/ficha/FichaTurismoTexto.html',
  'models/ItemListado',
  'text!tpl/listado/ItemView.html',
  'vars'
], function($, _, Backbone, FichaViewTemplate, FichaTexto, ItemListado, ItemViewTemp, vars){


  FichaView = Backbone.View.extend({ 
    url : "",
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		console.log( vars.getTituloActual());
		var data = {titulo : vars.getTituloActual()};
		var compiledTemplate = _.template( FichaViewTemplate, data );
		this.$el.html(compiledTemplate);
		
		var self = this;
		
				
		
		var item = new ItemListado({url: url_datos + this.url + "?h=" + vars.login["hash"],template: FichaViewTemplate});
		self.data = Array();

		item.fetch({prefill:vars.cacheActivo, data: {},prefillSuccess:self.rellenarDatos,success:self.rellenarDatos});
		

        return this;
    },
	initialize: function(options) {
	     _.bindAll(this, 'render', 'eventos','rellenarDatos'); // every function that uses 'this' as the current object should be in here


		this.url = options.url;
		this.titulo = options.titulo;		
		this.compartir = Array();
		this.compartir["mensaje"] = "";
		this.compartir["titulo"] = "";
		this.compartir["imagen"] = "";	
    },
	rellenarDatos: function(item){
		var self = this;
				data = {};
				data.titulo = item.attributes.nombre;
				data.descripcion = item.attributes.descripcion;
				data.direccion = item.attributes.direccion;
				data.codigopostal = item.attributes.cp;
				data.poblacion = item.attributes.poblacion;
				data.provincia = item.attributes.provincia;
				data.telefono = item.attributes.telefono;
				data.email = item.attributes.email;
				data.id = item.attributes.id;
				data.imagen = item.attributes.imagen;
								  
								  
				data.imagenes = Array();
								  
				delete data.distancia;
				
				if (typeof(item.attributes.latitud) != "undefined" && typeof(item.attributes.longitud) != "undefined" ){
					data.distancia = vars.Distancia( item.attributes.latitud, item.attributes.longitud);
				}

				data.misplanes = false;
				if (typeof(item.attributes.misplanes) != "undefined" && item.attributes.misplanes > 0)
					data.misplanes = true;

				self.data = data;
				var compiledTemplate = _.template( FichaTexto, data );
				
				
				self.compartir["mensaje"] = $(data.descripcion).text() + " " + data.direccion + " " + data.codigopostal + " "  + data.poblacion + " (" + data.provincia + ") Telf: " + data.telefono + " Email: " + data.email;
				self.compartir["titulo"] = data.titulo;
				self.compartir["imagen"] = data.imagen;	


				//$("#container > div.page:last-child #ficha").html(compiledTemplate);
				//self.mostrarFicha(item);
				self.$el.find("div.contenido").html(compiledTemplate);				
				

				self.eventos();
	},
	eventos: function(e) {
		var self = this;
		
		self.$("div.pestanas div.pestana").hide();
		self.$("div.pestanas div.pestana:eq(0)").show();
		
		self.$("div.pestanas div.nav a").on("click",function(e){
			self.$("div.pestanas div.nav a.abierto").removeClass("abierto");
			$(this).addClass("abierto");
			
			
			e.preventDefault();
			e.stopImmediatePropagation();
			self.$("div.pestanas div.pestana").hide();
			self.$("div.pestanas div.pestana:eq("+$(this).index()+")").show();
			
		});
		
		if (self.$("div.carrusel div.item").length > 1){
			var hammertime = self.$("div.carrusel div.item").hammer();
			hammertime.on("swiperight", function(ev) {
				$(this).animate({left:"100%"});
				proximo = $(this).prev();
				
				
				if (proximo.length <= 0){
					proximo = $(this).parent().find("div.item:last-child");
				}
				
				self.$("div.carrusel div.control span.select").removeClass("select");
				self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
				
				proximo.css({left:"-100%"}).show();
				proximo.animate({left:0});
			});
			hammertime.on("swipeleft", function(ev) {
				$(this).animate({left:"-100%"});
				
				proximo = $(this).next();
				
				if (proximo.length <= 0){
					proximo = $(this).parent().find("div.item:eq(0)");
				}
				
				
				self.$("div.carrusel div.control span.select").removeClass("select");
				self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
				
				proximo.css({left:"100%"}).show();
				proximo.animate({left:0});
				
			});
			
			
			$("div.carrusel div.item").on("touchmove",function(e){e.preventDefault()});
		}
		$("div.listado.promociones a").on("click",function(e){
			self.clickpromo(e);
		});

		self.$("a.share").on("click",function(e){
			window.plugins.socialsharing.share(self.compartir["mensaje"], self.compartir["titulo"], self.compartir["imagen"]);
			e.preventDefault();
		});
		
		self.$("a.miespacio").on("click",function(e){
			if (vars.login["logueado"] == false){
				location.hash = "#login";				
			}
			else{
					estado = (!self.$("a.miespacio").hasClass("activo"))?"activo":"desactivado";
					if(estado=="desactivado"){
						mensaje = "¿Estas seguro que deseas eliminarlo de tus planes?";
						botones = "Eliminar,Cancelar";
					}
					else{
						mensaje = "¿Estás seguro que deseas añadirlo a tus planes?";
						botones = "Añadir,Cancelar";
					}
					
					navigator.notification.confirm(
						mensaje,  // message
						function(boton){
							if(boton == 1){
								self.$("a.miespacio").addClass("cargando");
								
								$.ajax({
									type: "POST",
									url: url_datos + "anadiraplanes",
									data: {
										hash: vars.login["hash"],
										id_turismo: self.data.id,
										estado: estado
									},
									success:function(result){
										var obj = JSON.parse(result);
										
										if (typeof(obj.estado) != "undefined" && obj.estado == "activo"){
											self.$("a.miespacio").removeClass("cargando");
											self.$("a.miespacio").addClass("activo");
											/*navigator.notification.alert(
												'Añadido a tus planes!',  // message
												function(){},  			  // callback
												'Mis planes',            // title
												'Ok'                     // buttonName
											);*/
										}
										else{
											self.$("a.miespacio").removeClass("cargando");
											self.$("a.miespacio").removeClass("activo");
										}
				
									}
								});
							}
							
						},              // callback to invoke with index of button pressed
						'Mis planes',            // title
						botones       // buttonLabels
					);
			}
				
				
				
			
			e.preventDefault();
		});
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goBack();
    },
	clickpromo: function (event){
		vars.putSeccion($(event.currentTarget).find("span.titulo").html());
	}
  });
  // Our module now returns our view
  return FichaView;
});