// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/ficha/FichaView.html',
  'text!tpl/ficha/FichaTexto.html',
  'models/ItemListado',
  'text!tpl/listado/ItemView.html',
  'socialsharing',
  'modal',
  'vars'
], function($, _, Backbone, FichaViewTemplate, FichaTexto, ItemListado, ItemViewTemp, socialsharing, modal,vars){


  FichaView = Backbone.View.extend({ 
    url : "",
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var data = {titulo : vars.getTituloActual()};
		var compiledTemplate = _.template( FichaViewTemplate, data );
		this.$el.html(compiledTemplate);
		
		var self = this;
		
				
		
		var item = new ItemListado({url: url_datos + this.url+ "?h=" + vars.login["hash"],template: FichaViewTemplate});

		self.data = Array();
		item.fetch({prefill:vars.cacheActivo, data: {},prefillSuccess: self.rellenarDatos,success: self.rellenarDatos,error:function(collection, response, options){
			if (vars.online == false){
				self.$el.find("div.loading").hide();
				self.$("div.scroller div.contenido").append('<p class="no_results">Necesitas estar conectado a internet para obtener los datos.</p>');
			}
		}});


        return this;
    },
	initialize: function(options) {
	     _.bindAll(this, 'render', 'eventos', 'rellenarDatos'); // every function that uses 'this' as the current object should be in here


		this.url = options.url;
		this.titulo = options.titulo;	
		
		this.compartir = Array();
		this.compartir["mensaje"] = "";
		this.compartir["titulo"] = "";
		this.compartir["imagen"] = "";	
		
    },
	rellenarDatos:function(item){
		var self = this;
		
				// Si vienes directamente a esta página los datos se almacenan directos en item, y si vienes desde una página anterior en item.attributes (No se porque, es algo de backbone)
				if (typeof(item.attributes) == "undefined"){
					atributos = item;
				}
				else{
					atributos = item.attributes;
				}
			
				data = {};
				data.titulo = atributos.nombre;
				data.descripcion = atributos.descripcion;
				data.direccion = atributos.direccion;
				data.codigopostal = atributos.cp;
				data.poblacion = atributos.poblacion;
				data.provincia = atributos.provincia;
				data.telefono = atributos.telefono;
				data.email = atributos.email;
				data.id = atributos.id;
				data.imagen = atributos.imagen;
				data.web = atributos.web;
				data.horario= atributos.horario;
				
				data.imagenes = Array()
				if (typeof(atributos.imagenes) != "undefined" )
					data.imagenes = atributos.imagenes;
				  
				delete data.distancia;
				
				data.misplanes = false;
				if (typeof(atributos.misplanes) != "undefined" && atributos.misplanes > 0)
					data.misplanes = true;
				
				if (typeof(atributos.latitud) != "undefined" && typeof(atributos.longitud) != "undefined" ){
					data.distancia = vars.Distancia( atributos.latitud, atributos.longitud);
				}
				var total_promos = 0;
				if (typeof(atributos.promociones) != "undefined"){
					total_promos = atributos.promociones.length;
				}
				data.total_promos = total_promos;				

				self.data = data;

				var compiledTemplate = _.template( FichaTexto, data );
				
				
				self.compartir["mensaje"] = $(data.descripcion).text() + " " + data.direccion + " " + data.codigopostal + " "  + data.poblacion + " (" + data.provincia + ") Telf: " + data.telefono + " Email: " + data.email;
				self.compartir["titulo"] = data.titulo;
				self.compartir["imagen"] = data.imagen;	
				
				
				
				//$("#container > div.page:last-child #ficha").html(compiledTemplate);
				//self.mostrarFicha(item);
				self.$("div.contenido").html(compiledTemplate);				
				

				if (total_promos > 0){
					for(i = 0; i < total_promos; i++){
						
						Aux = vars.parse_date(atributos.promociones[i].valido_hasta)
						var valido_hasta_conv = Aux.getDate() + "/" + Aux.getMonth() + "/" + Aux.getFullYear();

						var data = {link: "#ficha-promocion/" + atributos.promociones[i].id,
									imagen: atributos.promociones[i].imagen,
									titulo: atributos.promociones[i].titulo,
									valido_hasta: valido_hasta_conv,
									gusta: atributos.promociones[i].gustas,
									vistas: atributos.promociones[i].vistas,
									nombre_empresa: null,
									texto:null
						};
						var compiledTemplate = _.template( ItemViewTemp, data );
		
						self.$("div.contenido div.promociones div.listado ul").append("<li>" + compiledTemplate + "</li>");
					}
				}
				else{
						self.$("div.contenido div.promociones div.listado").html('<p class="no_results">Sin resultados</p>');
				}

				
				self.$('p.no_results').hide();

				

				self.eventos();
		
	},
	eventos: function(e) {
		var self = this;

		self.$("div.pestanas div.pestana").hide();
		self.$("div.pestanas div.pestana:eq(0)").show();
		
		if (typeof(vars.fichacomerciotabpromociones) !== "undefined"){
			if (vars.fichacomerciotabpromociones == true){
				self.$("div.pestanas div.pestana").hide();
				self.$("div.pestanas div.pestana:eq(1)").show();

				self.$("div.pestanas div.nav a.abierto").removeClass("abierto");
				self.$("div.pestanas div.nav a:eq(1)").addClass("abierto");
				
				vars.fichacomerciotabpromociones = false;
			}
		}

		
		
		
		
		self.$("div.pestanas div.nav a").on("click",function(e){
			self.$("div.pestanas div.nav a.abierto").removeClass("abierto");
			$(this).addClass("abierto");
			
			
			e.preventDefault();
			e.stopImmediatePropagation();
			self.$("div.pestanas div.pestana").hide();
			self.$("div.pestanas div.pestana:eq("+$(this).index()+")").show();
			
			
			
		});
		
		
		
		self.$("div.listado.promociones a").on("click",function(){
				vars.fichacomerciotabpromociones = true;
		});
		
		
		
		
		self.$("a.abrir-modal").on("click",function(e){
			modal.show('<iframe src="'+$(this).attr("href")+'"></iframe>');
			e.preventDefault();
		});
		
		
		if (self.$("div.carrusel div.item").length > 1){
		
			var hammertime = self.$("div.carrusel div.item").hammer();
			hammertime.on("swiperight", function(ev) {
				$(this).animate({left:"100%"});
				proximo = $(this).prev();
				
				
				if (proximo.length <= 0){
					proximo = $(this).parent().find("div.item:last-child");
				}
				
				self.$("div.carrusel div.control span.select").removeClass("select");
				self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
				
				proximo.css({left:"-100%"}).show();
				proximo.animate({left:0});
				clearInterval(intervaloCarrusel);
			});
			hammertime.on("swipeleft", function(ev) {
				$(this).animate({left:"-100%"});
				
				proximo = $(this).next();
				
				if (proximo.length <= 0){
					proximo = $(this).parent().find("div.item:eq(0)");
				}
				
				
				self.$("div.carrusel div.control span.select").removeClass("select");
				self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
				
				proximo.css({left:"100%"}).show();
				proximo.animate({left:0});
				clearInterval(intervaloCarrusel);
			});
			
					
			clearInterval(intervaloCarrusel);
				var intervaloCarrusel = setInterval(function(){
					indexActual = self.$("div.carrusel div.control span.select").index();
					
					itemActual = self.$("div.carrusel div.item:eq("+indexActual+")");
					
					
					
					itemActual.animate({left:"-100%"});
					
					proximo = itemActual.next();
					
					if (proximo.length <= 0){
						proximo = itemActual.parent().find("div.item:eq(0)");
					}
					
					self.$("div.carrusel div.control span.select").removeClass("select");
					self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
		
					
					proximo.css({left:"100%"}).show();
					proximo.animate({left:0});
				},3000);
		}
		
		
		
		
		
		
		
		
		
		//$("div.carrusel div.item").on("touchmove",function(e){e.preventDefault()});
		self.$("div.listado.promociones a").on("click",function(e){
			self.clickpromo(e);
		});

		self.$("a.share").on("click",function(e){
			window.plugins.socialsharing.share(self.compartir["mensaje"], self.compartir["titulo"], self.compartir["imagen"]);
			e.preventDefault();
		});
		
		self.$("a.web").on("click",function(event){
			window.open($(event.currentTarget).attr("href"),'_system','location=yes');
			event.preventDefault();
		});
		
		/*self.$("h2").on("click",function(e){
			if ($("body").find("#efecto-especial-favoritos").length == 0){ 
				$("body").append('<span id="efecto-especial-favoritos"><span class="icono icon-anadir_mi_espacio"></span></span>');
			}
			$("footer a:eq(0)").removeClass("destacar");
			$("#efecto-especial-favoritos").addClass("animate");
			
			setTimeout(function(){$("#efecto-especial-favoritos").removeClass("animate");$("footer a:eq(0)").addClass("destacar");	},800);
		});*/
		
		
		self.$("a.miespacio").on("click",function(e){
			if (vars.login["logueado"] == false){
				location.hash = "#login";				
			}
			else{
					estado = (!self.$("a.miespacio").hasClass("activo"))?"activo":"desactivado";
					if(estado=="desactivado"){
						mensaje = "¿Estas seguro que deseas eliminarlo de tus planes?";
						botones = "Eliminar,Cancelar";
					}
					else{
						mensaje = "¿Estás seguro que deseas añadirlo a tus planes?";
						botones = "Añadir,Cancelar";
					}
					
					navigator.notification.confirm(
						mensaje,  // message
						function(boton){
							if(boton == 1){
								self.$("a.miespacio").addClass("cargando");
								
								$.ajax({
									type: "POST",
									url: url_datos + "anadiraplanes",
									data: {
										hash: vars.login["hash"],
										id_comercio: self.data.id,
										estado: estado
									},
									success:function(result){
										var obj = JSON.parse(result);
										
										if (typeof(obj.estado) != "undefined" && obj.estado == "activo"){
											self.$("a.miespacio").removeClass("cargando");
											self.$("a.miespacio").addClass("activo");
											navigator.notification.alert(
												'Añadido a tus planes!',  // message
												function(){},  			  // callback
												'Mis planes',            // title
												'Ok'                     // buttonName
											);
										}
										else{
											self.$("a.miespacio").removeClass("cargando");
											self.$("a.miespacio").removeClass("activo");
										}
				
									}
								});
							}
							
						},              // callback to invoke with index of button pressed
						'Mis planes',            // title
						botones       // buttonLabels
					);
				
			}			
			
			e.preventDefault();
		});		
		
		
		
		
		
		
		
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goBack();
    },
	clickpromo: function (event){
		vars.putSeccion($(event.currentTarget).find("span.titulo").html());
	}
  });
  // Our module now returns our view
  return FichaView;
});