// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/HomeView.html',
  'hammer',
  'hammer_jquery',
  'vars'
], function($, _, Backbone, HomeViewTemplate, Hammer, Jqueryhammer, vars){ 
  HomeView = Backbone.View.extend({
	ciudad : 0,
	events: {
	  'click div.listado a': 'click'
	},
    render: function(){
		var self = this;
		
		var data = {ciudad: this.ciudad,titulo: vars.getTituloActual()};
		var compiledTemplate = _.template( HomeViewTemplate, data );

		this.$el.html(compiledTemplate);
		if (localStorage.getItem('homeCache' + this.ciudad) !== null){
			self.rellenarDatos(localStorage.getItem('homeCache' + this.ciudad));
		}

		
		$.ajax({
			url: url_datos + "/ciudad/"+ this.ciudad + "/home",
			cache: vars.cacheActivo,
			success:function(result){
				localStorage.setItem('homeCache' + self.ciudad ,result)
				self.rellenarDatos(localStorage.getItem('homeCache' + self.ciudad));
			}
		});
		
		
		
		
		

		
        return this;
    },
	initialize: function(options) {
		this.ciudad = options.ciudad;	
    },
	rellenarDatos: function(result){
		var self = this;

		var obj = JSON.parse(result);

		if (typeof(obj.planes) != "undefined" && obj.planes > 0){
			self.$("div.listado ul li:eq(0) a").append('<div class="numero"><span>'+obj.planes+'</span></div>');
		}

		if (typeof(obj.tiendas) != "undefined" && obj.tiendas > 0){
			self.$("div.listado ul li:eq(1) a").append('<div class="numero"><span>'+obj.tiendas+'</span></div>');
		}

		if (typeof(obj.ofertas) != "undefined" && obj.ofertas > 0){
			self.$("div.listado ul li:eq(2) a").append('<div class="numero"><span>'+obj.ofertas+'</span></div>');
		}

		if (typeof(obj.guia) != "undefined" && obj.guia > 0){
			self.$("div.listado ul li:eq(3) a").append('<div class="numero"><span>'+obj.guia+'</span></div>');
		}

		if (typeof(obj.ademas) != "undefined" && obj.ademas > 0){
			self.$("div.listado ul li:eq(4) a").append('<div class="numero"><span>'+obj.ademas+'</span></div>');
		}
		
		if (typeof(obj.carrusel) != "undefined"){
			//self.$("div.listado ul li:eq(4) a").append('<div class="numero"><span>'+obj.ademas+'</span></div>');
			totalCarrusel = Object.keys(obj.carrusel).length;
			if (totalCarrusel > 0){
				self.$("div.carrusel div.items").html('')
				
				self.$("div.carrusel div.control").show().html('');
				
				$.each(obj.carrusel, function(index, value) {
					//console.log(value.titulo);
					
					if (value.link != ""){
						self.$("div.carrusel div.items").append('<div class="item"><a href="'+value.link+'" title="'+value.titulo+'"><img src="'+value.imagen+'" /></a></div>')
					}
					else{
						self.$("div.carrusel div.items").append('<div class="item"><img src="'+value.imagen+'" /></div>')
					}
					
					self.$("div.carrusel div.control").append('<span class=""></span>')
				}); 
				
				self.$("div.carrusel div.control span:eq(0)").addClass('select')
			}
			
			
			
			
			
			if (totalCarrusel > 1){
				var hammertime = this.$("div.carrusel div.item").hammer();
				
				hammertime.on("swiperight", function(ev) {
					$(this).animate({left:"100%"});
					proximo = $(this).prev();
					
					if (proximo.length <= 0){
						proximo = $(this).parent().find("div.item:last-child");
					}
		
					self.$("div.carrusel div.control span.select").removeClass("select");
					self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
		
					proximo.css({left:"-100%"}).show();
					proximo.animate({left:0});
					clearInterval(intervaloCarrusel);
				});
				hammertime.on("swipeleft", function(ev) {
					$(this).animate({left:"-100%"});
					
					proximo = $(this).next();
					
					if (proximo.length <= 0){
						proximo = $(this).parent().find("div.item:eq(0)");
					}
					
					self.$("div.carrusel div.control span.select").removeClass("select");
					self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
		
					
					proximo.css({left:"100%"}).show();
					proximo.animate({left:0});
					clearInterval(intervaloCarrusel);
				});
				
				this.$("div.carrusel div.item").on("touchmove",function(e){e.preventDefault()});
				this.$("div.carrusel a").on("click",function(){vars.putSeccion($(this).attr("title"))});
			
			
			
				clearInterval(intervaloCarrusel);
				var intervaloCarrusel = setInterval(function(){
					
					totalcarrusel = self.$("div.carrusel div.control span").length;
					if (totalcarrusel > 1){
						indexActual = self.$("div.carrusel div.control span.select").index();
						
						itemActual = self.$("div.carrusel div.item:eq("+indexActual+")");
						
						itemActual.animate({left:"-100%"});
						
						proximo = itemActual.next();
						
						if (proximo.length <= 0){
							proximo = itemActual.parent().find("div.item:eq(0)");
						}
						
						self.$("div.carrusel div.control span.select").removeClass("select");
						self.$("div.carrusel div.control span:eq("+proximo.index()+")").addClass("select");
			
						
						proximo.css({left:"100%"}).show();
						proximo.animate({left:0});
					}
					
		
				},3000);

			}
			
			
			
		}
},
	goBack: function(e) {
		e.preventDefault();
		vars.goBack();
    },
	click: function(event) {
		//e.preventDefault();
		vars.putSeccion($(event.currentTarget).find("span.titulo").html());
    }
  });
  // Our module now returns our view
  return HomeView;
});