// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/InfoView.html',
  'text!tpl/informacion/CayetanoView.html',
  'text!tpl/informacion/FaqView.html',
  'text!tpl/informacion/CuentaView.html',
  'text!tpl/informacion/ConfiguracionView.html',
  'vars'
], function($, _, Backbone, InfoViewTemplate, CayetanoView, FaqView, CuentaView, ConfiguracionView, vars){ 
  PlanesCayetano = Backbone.View.extend({
	ciudad : 0,
	events: {
	  'click a.back-button': 'goBack',
	  'click div.listado a': 'click'
	},
    render: function(){
		var self = this;
		
		this.data =  {ciudad: self.ciudad,titulo: vars.getTituloActual(), logueado: vars.login["logueado"]};
		self.compiledTemplate = "";
		switch(this.seccion)
		{
		case "cayetano":
			/*require(
				[ 'vars'],
				function(){*/
					self.compiledTemplate = _.template( CayetanoView, self.data );
					self.$el.html(self.compiledTemplate);
				/*}
			);*/

		  break;
		case "faq":
			/*require(
				[ 'text!tpl/informacion/FaqView.html','vars'],
				function(FaqView){*/
					self.compiledTemplate = _.template( FaqView, self.data );
					self.$el.html(self.compiledTemplate);
				/*}
			);*/
		  break;
		case "cuenta":
			/*require(
				[ 'text!tpl/informacion/CuentaView.html','vars'],
				function(CuentaView){*/
					self.compiledTemplate = _.template( CuentaView, self.data );
					self.$el.html(self.compiledTemplate);
				/*}
			);*/
		  break;
		case "configuracion":
			/*require(
				[ 'text!tpl/informacion/ConfiguracionView.html','vars'],
				function(ConfiguracionView){**/
					self.compiledTemplate = _.template( ConfiguracionView, self.data );
					self.$el.html(self.compiledTemplate);
				/*}
			);*/
		  break;
		default:
			this.compiledTemplate = _.template( InfoViewTemplate, this.data );
			this.$el.html(self.compiledTemplate);
		}
		
		
		
        return this;
    },
	initialize: function(options) {
		this.ciudad = options.ciudad;
		this.seccion = options.seccion;	
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goBack();
    },
	click: function(event) {
		//e.preventDefault();
		vars.putSeccion($(event.currentTarget).find("span.titulo").html());
    }
  });
  // Our module now returns our view
  return PlanesCayetano;
});