define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/LoginView.html',
  'text!tpl/LoginFormView.html',
  'vars',
], function($, _, Backbone, LoginView, LoginFormView, vars){
	
  HomeView = Backbone.View.extend({
	events: {
	  'click a.volver2': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var self = this;
				
		var data = {};
		
		
		
		self.compiledTemplate = "";

		switch(this.seccion)
		{
		case "formulario":

			require(
				[ 'text!tpl/LoginFormView.html','vars'],
				function(LoginFormView){
					self.compiledTemplate = _.template( LoginFormView);
					self.$el.html(self.compiledTemplate);
					
					self.$("form").on("submit",function(e){
						self.$("div.loading").fadeIn();
						self.$("div.errores").hide().html();
						$.ajax({
							type: "POST",
							url: url_datos + "login",
							data: {
								usuario: self.$("form input.email").val(),
								contrasena: self.$("form input.contrasena").val()
							},
							success:function(result){
								var obj = JSON.parse(result);
								self.$("div.loading").fadeOut();
			
								if (typeof(obj.hash) !== "undefined"){
									vars.login["logueado"] = true;
									vars.login["email"] = self.$("form input.email").val();
									vars.login["hash"] = obj.hash;
									vars.initLogin();
									
									try {
										localStorage.setItem("email", self.$("form input.email").val());
										localStorage.setItem("hash", obj.hash);
			
										} catch (e) {
										if (e == QUOTA_EXCEEDED_ERR) {
											alert('Quota exceeded!');
										}
									}
			
									pageslider_mostrandomodal = false;
									$("div.oscurecer").fadeOut();
									$("body").removeClass("sinscroll");

									$("#modal").removeClass("abrir");
									location.hash = "#info/cuenta"; 
									vars.putSeccion("Mi cuenta");
								}
								else{
									vars.login["logueado"] = false;
									vars.login["email"] = "";
									vars.initLogin();
									
									//self.$("div.errores").slideDown().html("<p>Usuario o contraseña incorrectos!</p>");
									navigator.notification.alert(
										"Usuario o contraseña incorrectos!",  // message
										function(){},  			  // callback
										'Error!',            // title
										'Ok'                     // buttonName
									);

								}
								
							}
						});
						e.preventDefault();
					});

					
					
					
					
					
					
				}
			);

		  break;
		case "registro":

			require(
				[ 'text!tpl/LoginRegistroView.html','vars'],
				function(LoginRegistroView){
					self.compiledTemplate = _.template( LoginRegistroView);
					self.$el.html(self.compiledTemplate);
					
					self.$("form").on("submit",function(e){
						self.$("div.errores").slideUp().html("enviando formulario");
						
						ErrorFormularioRegistro = false;
						Errores = Array();
						
						if (self.$("form input.contrasena").val() != self.$("form input.confirmarcontrasena").val()){
							ErrorFormularioRegistro = true;
							Errores.push("Las contraseñas tienen que ser iguales");
						}
						
						if (vars.validateEmail(self.$("form input.email").val()) == false){
							ErrorFormularioRegistro = true;
							Errores.push("Email incorrecto");
						}
						
						if (self.$("form input.nombre").val() == "" || self.$("form input.email").val() == "" || self.$("form input.contrasena").val() == "" || self.$("form input.confirmarcontrasena").val() == "" || self.$("form input.sexo").val() == ""){
							ErrorFormularioRegistro = true;
							Errores.push("Todos los campos son obligatórios");
						}
						
						
						if (!ErrorFormularioRegistro){
							self.$("div.loading").fadeIn();
							self.$("div.errores").hide().html();
							$.ajax({
								type: "POST",
								url: url_datos + "registrarse",
								data: {
									nombre: self.$("form input.nombre").val(),
									email: self.$("form input.email").val(),
									contrasena: self.$("form input.contrasena").val(),
									sexo: self.$("form select.sexo").val()
								},
								success:function(result){
									var obj = JSON.parse(result);
									self.$("div.loading").fadeOut();

									if (typeof(obj.hash) !== "undefined"){
										vars.login["logueado"] = true;
										vars.login["hash"] = obj.hash;
										vars.initLogin();
										
										try {
											localStorage.setItem("hash", obj.hash);
				
											} catch (e) {
											if (e == QUOTA_EXCEEDED_ERR) {
												alert('Quota exceeded!');
											}
										}
										pageslider_mostrandomodal = false;
										$("div.oscurecer").fadeOut();
										$("body").removeClass("sinscroll");
										$("#modal").removeClass("abrir");
										location.hash = "#info/cuenta"; 
										vars.putSeccion("Mi cuenta");
									}
									else if (typeof(obj.errores) !== "undefined"){
										self.$("div.loading").fadeOut();

										erroreslength = obj.errores.length;
										errorestexto = "";
										for(j=0;j<erroreslength;j++){
											errorestexto += obj.errores[j] + '\n';
										}
										navigator.notification.alert(
											errorestexto, 		 // message
											function(){},  			  // callback
											'Error!',            // title
											'Ok'                 // buttonName
										);
									}
								}
							});
						}
						else{
							length = Errores.length;
							errorestexto = "";
							for (var i = 0;i<length;i++){
								errorestexto += Errores[i] + '\n';
							}
							navigator.notification.alert(
								errorestexto, 		 // message
								function(){},  			  // callback
								'Error!',            // title
								'Ok'                 // buttonName
							);

						}
						e.preventDefault();
					});

					
					
					
				}
			);

		  break;
		case "recuperar-contrasena":

			require(
				[ 'text!tpl/LoginRecuperarView.html','vars'],
				function(LoginRecuperarView){
					self.compiledTemplate = _.template( LoginRecuperarView);
					self.$el.html(self.compiledTemplate);
					
					self.$("form").on("submit",function(e){
						self.$("div.loading").fadeIn();
						self.$("div.errores").hide().html();
						$.ajax({
							type: "POST",
							url: url_datos + "recuperarcontrasena",
							data: {
								email: self.$("form input.email").val(),
							},
							success:function(result){
								var obj = JSON.parse(result);
								self.$("div.loading").fadeOut();
			
								if (obj.ok == 1){
									self.$("form"). hide();
									self.$el.append('<p class="ok">Se ha enviado un e-mail para recuperar la contraseña.</p>');
								}
								else{
									self.$("div.loading").fadeOut();
									//self.$("div.errores").html("");
									//self.$("div.errores").append('<p>Email incorrecto.</p>').slideDown();
									navigator.notification.alert(
										"Email incorrecto.", 		 // message
										function(){},  			  // callback
										'Error!',            // title
										'Ok'                 // buttonName
									);
									
									//self.$("div.errores").slideDown();
								}
								
							}
						});
						e.preventDefault();
					});

					
				}
			);

		  break;
		default:
			this.compiledTemplate = _.template( LoginView );
			this.$el.html(self.compiledTemplate);
		}
		
		
		
		
		
		
		
			
		this.eventos();		

        return this;
    },
	initialize: function(options) {
	    _.bindAll(this, 'render', 'eventos','LoginFacebook'); // every function that uses 'this' as the current object should be in here
		//this.view = options.view;
		this.seccion = options.seccion;	
		
    },
	goBack: function(e) {
		e.preventDefault();
		window.history.back();
    },
	eventos: function(e) {
		var self = this;
		
		
		this.$("a.facebook").on("click",function(e){
							
			self.LoginFacebook();		

			e.preventDefault();
		
		
		});
	
		
		
		
		
    },
		// Registro / Login utilizando Facebook.
		LoginFacebook: function()
		{
			// Flag que indica que ya hemos cargado previamente la librería.
			if(vars.flagfacebook == false)
			{
				// Comprobamos carga previa de librerías necesarias.
				if(typeof CDV == 'undefined') alert('Ocurrió un fallo cargando cdv-plugin-fb-connect');
				if(typeof FB == 'undefined') alert('Ha sido imposible conectar con facebook.');
				// Conectamos con Facebook.
				FB.init({appId: "1377982829129309", nativeInterface: CDV.FB, useCachedDialogs: false, cookie: true, xfbml: true, oauth: true});
				// Generamos flag de carga.
				vars.flagfacebook = true;
			}
			// Login con Facebook.
			FB.login(
				function(response)
				{
					FB.api('/me', function(response)
					{
						$.ajax({
							type: "POST",
							url: url_datos + "registrofacebook",
							data:
							{
								nombre:			response.name,
								email: 			response.email,
								facebook_id:	response.id,
								sexo: 			response.gender
							},
							success:function(result)
							{
								var obj 		= JSON.parse(result);
								self.$("div.loading").fadeOut();
								if(typeof(obj.hash) !== "undefined")
								{
									vars.login["logueado"]		= true;
									vars.login["hash"] 			= obj.hash;
									try
									{
										localStorage.setItem("hash", obj.hash);
									}
									catch (e)
									{
										if (e == QUOTA_EXCEEDED_ERR)
										{
											alert('Quota exceeded!');
										}
									}
									pageslider_mostrandomodal 		= false;
									$("div.oscurecer").fadeOut();
									$("body").removeClass("sinscroll");
									$("#modal").removeClass("abrir");
									vars.initLogin();
									location.hash 					= "#info/cuenta";
									vars.putSeccion("Mi cuenta");
								}
							}
						});
					});
				},
				{
					scope: "email"
				}
			);
		}
	});
	// Our module now returns our view
	return HomeView;
});