define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/MapView.html',
  'models/ItemListado',
  'vars',
], function($, _, Backbone, MapViewTemplate, ItemListado, vars){
	
  HomeView = Backbone.View.extend({
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var self = this;
		
		this.idcanvas = Math.floor((Math.random()*100)+1);
		
		var data = {idcanvas: "googlemaps-" + this.idcanvas};
		var compiledTemplate = _.template( MapViewTemplate, data );

		this.$el.html(compiledTemplate);		

		
		var item = new ItemListado({url: url_datos + this.url, template: MapViewTemplate});


		item.fetch({cache:vars.cacheActivo, data: {}}).done(function (item) {


			
			
			$('#googlemaps-' + self.idcanvas).height($('#googlemaps-' + self.idcanvas).parent().parent().height());
			// Si vienes directamente a esta página los datos se almacenan directos en item, y si vienes desde una página anterior en item.attributes (No se porque, es algo de backbone)
			if (typeof(item.attributes) == "undefined"){
				atributos = item;
			}
			else{
				atributos = item.attributes;
			}

			var longitud = atributos.longitud;
			var latitud = atributos.latitud;
			var nombre = atributos.nombre;
			
			
			require(
				['gmaps'],
				function(gmaps){

					var mapa = new GMaps({
					  div: '#googlemaps-' + self.idcanvas,
					  lat: latitud,
					  lng: longitud,
					  height:$('#googlemaps-' + self.idcanvas).parent().parent().height()
					});
					
					mapa.addMarker({
						lat: latitud,
						lng: longitud,
						title: nombre,
						icon: "https://maps.gstatic.com/mapfiles/ms2/micons/green-dot.png",
						click: function(e) {
						},
						infoWindow: {
							content: '<div class="infowindow"><p>'+nombre+'</p></div>'
						}
					});
					
					
					if (vars.posicion.latitud != 0 && vars.posicion.longitud != 0){
						var tuposicion = new google.maps.LatLng(vars.posicion.latitud,vars.posicion.longitud);
		
						mapa.drawRoute({
							origin: [vars.posicion.latitud, vars.posicion.longitud],
							destination: [latitud, longitud],
							travelMode: 'walking',
							strokeColor: '#131540',
							strokeOpacity: 0.6,
							strokeWeight: 6
						});
						mapa.addMarker({
							lat: vars.posicion.latitud,
							lng: vars.posicion.longitud,
							title: 'Estas aquí',
							icon: "https://maps.gstatic.com/mapfiles/ms2/micons/red-dot.png",
							infoWindow: {
								content: '<div class="infowindow"><p>Estas aquí</p></div>'
							}
						});
		
						
						
					}


				}
			);

			
		});













        return this;
    },
	initialize: function(options) {
	    _.bindAll(this, 'render'); // every function that uses 'this' as the current object should be in here
		this.url = options.url;
		vars.putSeccion("Mapa");
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goBack();
    },
	cargarMapa: function(e){
		
		
		
		
		
	}
  });
  // Our module now returns our view
  return HomeView;
});