define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/MisDatosView.html',
  'vars'
], function($, _, Backbone, MisDatosView, vars){
	
  HomeView = Backbone.View.extend({
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var self = this;
		
		
		var data = {noback : false};
		var compiledTemplate = _.template( MisDatosView, data );

		this.$el.html(compiledTemplate);
		self.$("form").hide();

		$.ajax({
			type: "GET",
			url: url_datos + "obtenermisdatos" + "?h=" + vars.login["hash"],
			success:function(result)
			{
				var obj 		= JSON.parse(result);
				self.$("div.loading").fadeOut();
				self.$("form").fadeIn();
				console.log(obj);
				
				if(typeof(obj.nombre) !== "undefined")
				{
					self.$("input.nombre").val(obj.nombre);
				}
				if(typeof(obj.email) !== "undefined")
				{
					self.$("input.email").val(obj.email);
				}
				if(typeof(obj.sexo) !== "undefined")
				{
					self.$("select.sexo option[value="+obj.sexo+"]").prop("selected",true);
				}
			}
		});
		
		self.cambiacontrasena = false;
		
		
		self.$("a.cambiarcontrasena").on("click",function(e){
			self.$("div.cambiarcontrasena").slideDown();
			self.cambiacontrasena = true;
			e.preventDefault();
		});
		
		self.$('form input[type="submit"]').on("click",function(e){
						
			ErrorFormularioRegistro = false;
			Errores = Array();
			if (self.cambiacontrasena == true){
				if (self.$("form input.contrasena").val() != self.$("form input.confirmarcontrasena").val()){
					ErrorFormularioRegistro = true;
					Errores.push("Las contraseñas tienen que ser iguales");
				}
			}
			if (vars.validateEmail(self.$("form input.email").val()) == false){
				ErrorFormularioRegistro = true;
				Errores.push("Email incorrecto");
			}
			
			if (self.$("form input.nombre").val() == "" || self.$("form input.email").val() == ""){
				ErrorFormularioRegistro = true;
				Errores.push("Nombre y email son obligatórios");
			}



			if(!ErrorFormularioRegistro){
				self.$("div.loading").fadeIn();
				self.$("form").fadeOut();
				$.ajax({
					type: "POST",
					url: url_datos + "guardarmisdatos" + "?h=" + vars.login["hash"],
					data: {
						nombre: self.$('form input.nombre').val(),
						sexo: self.$('form select.sexo').val(),
					},
					success:function(result)
					{
						var obj 		= JSON.parse(result);
						self.$("div.loading").fadeOut();
						self.$("form").fadeIn();
						
						if (typeof(obj.ok) !== "undefined" && obj.ok == 1){
							
							navigator.notification.alert(
								"Sus datos fueron actualizados.", 		 // message
								function(){},  			  // callback
								'Mis datos',            // title
								'Ok'                 // buttonName
							);
							
							
						}
						else if (typeof(obj.errores) !== "undefined"){
							erroreslength = obj.errores.length;
							errorestexto = "";
							for(j=0;j<erroreslength;j++){
								errorestexto += obj.errores[j] + '\n';
							}
							navigator.notification.alert(
								errorestexto, 		 // message
								function(){},  			  // callback
								'Error!',            // title
								'Ok'                 // buttonName
							);
						}
						
					}
				});
			}
			else{
				self.$("div.loading").fadeOut();
				self.$("form").fadeIn();
				length = Errores.length;
				errorestexto = "";
				for (var i = 0;i<length;i++){
					errorestexto += Errores[i] + '\n';
				}
				navigator.notification.alert(
					errorestexto, 		 // message
					function(){},  			  // callback
					'Error!',            // title
					'Ok'                 // buttonName
				);
							
			}
			e.preventDefault();
		});
		
		
		
		
		
		

        return this;
    },
	initialize: function(options) {
	    _.bindAll(this, 'render'); // every function that uses 'this' as the current object should be in here
		//this.view = options.view;
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goBack();
    }
  });
  // Our module now returns our view
  return HomeView;
});