// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/ficha/FichaView.html',
  'text!tpl/ficha/FichaNoticiasTexto.html',
  'models/ItemListado',
  'text!tpl/listado/ItemView.html',
  'socialsharing',
  'modal',
  'vars'
], function($, _, Backbone, FichaViewTemplate, FichaTexto, ItemListado, ItemViewTemp, socialsharing, modal, vars){


  FichaView = Backbone.View.extend({ 
    url : "",
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var data = {titulo : vars.getTituloActual()};
		var compiledTemplate = _.template( FichaViewTemplate, data );
		this.$el.html(compiledTemplate);
		
		var self = this;
		
//		console.log(vars.noticiasCache);
		var data = {};
		data.titulo = vars.noticiasCache[self.id].title;
		data.descripcion = '<p>'+vars.noticiasCache[self.id].description+"</p>";
		data.direccion = "";
		data.codigopostal = "";
		data.poblacion = "";
		data.provincia = "";
		data.telefono = "";
		data.email = "";
		data.id = "";
		data.imagen = vars.noticiasCache[self.id].image;		  
		
		var compiledTemplate = _.template( FichaTexto, data );
		self.$el.find("div.contenido").hide().fadeIn().html(compiledTemplate);

		//self.eventos();
		

        return this;
    },
	initialize: function(options) {
	     _.bindAll(this, 'render', 'eventos'); // every function that uses 'this' as the current object should be in here
		this.id = options.id;
    },
	eventos: function(e) {
		var self = this;
		
		self.$("div.pestanas div.pestana").hide();
		self.$("div.pestanas div.pestana:eq(0)").show();

		self.$("a.share").on("click",function(e){
			window.plugins.socialsharing.share('Message, subject, image and link', 'The subject', 'https://www.google.nl/images/srpr/logo4w.png', 'http://www.x-services.nl');
			e.preventDefault();
		});

		
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goBack();
    }
  });
  // Our module now returns our view
  return FichaView;
});