// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/PlanesView.html',
  'vars'
], function($, _, Backbone, PlanesViewTemplate, vars){ 
  PlanesCayetano = Backbone.View.extend({
	ciudad : 0,
	events: {
	  'click a.back-button': 'goBack',
	  'click div.listado a': 'click'
	},
    render: function(){
		var self = this;
		
		var data = {ciudad: this.ciudad,titulo: vars.getTituloActual()};
		var compiledTemplate = _.template( PlanesViewTemplate, data );

		this.$el.html(compiledTemplate);

				
		
		if (localStorage.getItem('planesCache' + this.ciudad) !== null){
			self.rellenarDatos(localStorage.getItem('planesCache' + this.ciudad));
		}
		
		$.ajax({
			url: url_datos + "/ciudad/"+ this.ciudad + "/planes",
			success:function(result){
				localStorage.setItem('planesCache' + self.ciudad, result)
				self.rellenarDatos(result);
			}
		});
		
		
        return this;
    },
	initialize: function(options) {
		this.ciudad = options.ciudad;	
    },
	rellenarDatos : function(result){
		var self = this;
		
		var obj = JSON.parse(result);
		vacio = true;
		
		self.$("div.loading").hide();
		self.$("div.listado").fadeIn();
		
		if (typeof(obj.tiendas) != "undefined" && obj.tiendas > 0){
			self.$("div.listado ul li:eq(0)").show();
			self.$("div.listado ul li:eq(0) a").append('<div class="numero"><span>'+obj.tiendas+'</span></div>');
			vacio = false;
		}
		else{
			self.$("div.listado ul li:eq(0)").hide();
		}

		if (typeof(obj.ofertas) != "undefined" && obj.ofertas > 0){
			self.$("div.listado ul li:eq(1)").show();
			self.$("div.listado ul li:eq(1) a").append('<div class="numero"><span>'+obj.ofertas+'</span></div>');
			vacio = false;
		}
		else{
			self.$("div.listado ul li:eq(1)").hide();
		}

		if (typeof(obj.eventos) != "undefined" && obj.eventos > 0){
			self.$("div.listado ul li:eq(2)").show();
			self.$("div.listado ul li:eq(2) a").append('<div class="numero"><span>'+obj.eventos+'</span></div>');
			vacio = false;
		}
		else{
			self.$("div.listado ul li:eq(2)").hide();
		}

		if (typeof(obj.lugares) != "undefined" && obj.lugares > 0){
			self.$("div.listado ul li:eq(3)").show();
			self.$("div.listado ul li:eq(3) a").append('<div class="numero"><span>'+obj.lugares+'</span></div>');
			vacio = false;
		}
		else{
			self.$("div.listado ul li:eq(3)").hide();
		}
		
		
		
		if (vacio){
			self.$("div.listado").append('<p class="no_results">Sin resultados</p>');
		}
		
	},
	goBack: function(e) {
		e.preventDefault();
		vars.goBack();
    },
	click: function(event) {
		//e.preventDefault();
		vars.putSeccion($(event.currentTarget).find("span.titulo").html());
    }
  });
  // Our module now returns our view
  return PlanesCayetano;
});