// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'text!tpl/RadioView.html',
  'socialsharing',
  'modal',
  'vars'
], function($, _, Backbone, RadioViewTemp, socialsharing, modal, vars){


  FichaView = Backbone.View.extend({ 
    url : "",
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var data = {titulo : vars.getTituloActual()};
		var compiledTemplate = _.template( RadioViewTemp, data );
		this.$el.html(compiledTemplate);
		
		var self = this;
		self.eventos();
		
		vars.mediaObject = new Media(this.url, self.onMediaSuccess, self.onMediaError, self.onMediaStatus);
        return this;
    },
	initialize: function(options) {
	     _.bindAll(this, 'render', 'eventos', 'onMediaSuccess'); // every function that uses 'this' as the current object should be in here
		this.url = options.url;
    },
	eventos: function(e) {
		var self = this;
		
		
		//self.$("a.play").hide();
		self.$("a.pause").hide();
		
		self.$("a.play").on("click",function(e){
			vars.mediaObject.play();
			self.$("a.play").hide();
			self.$("a.pause").show();
			e.preventDefault();
		});
		
		self.$("a.pause").on("click",function(e){
			self.$("a.play").show();
			self.$("a.pause").hide();
			vars.mediaObject.pause();
			e.preventDefault();
		});
		
		
		
    },
	onMediaSuccess : function (){
		var self = this;
		//this.theMedia.play();
		self.$("a.play").show();
		self.$("a.pause").show();
		
		$("div.controles_media p.status").html("Media success");

		
	},
	onMediaError : function (e){
		if (e.code != 0){
			  var msgText = "Media error: " + e.message + "(" + e.code + ")";
			  console.log(msgText);
			  navigator.notification.alert(msgText, null, "Media Error");
			  $("div.controles_media p.status").html("Media ERROR");
			  
		}
	},
	onMediaStatus : function (statusCode){
		
		
		switch(statusCode)
		{
			case 1:
				$("div.controles_media p.status").html("Cargando radio...");
			break;
			case 2:
				$("div.controles_media p.status").html("Reproduciendo");
			break;
			case 3:
				$("div.controles_media p.status").html("Pausado");
			break;
		}		
		
	},
	goBack: function(e) {
		e.preventDefault();
		vars.goBack();
    }
  });
  // Our module now returns our view
  return FichaView;
});