// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'views/ListView',
  'text!tpl/ListadoView.html'
], function($, _, Backbone, ListView, AyudaViewTemplate){


  ListadoView = Backbone.View.extend({
    url : "",
    link : "",
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){

	
		// Using Underscore we can compile our template with data
		var data = {};
		var compiledTemplate = _.template( AyudaViewTemplate, data );

		//$(this.elemento).find("div.contenido").html(compiledTemplate);
		
		
		var listview = new ListView({url:this.url, link:this.link});
		$(this.elemento).find("div.contenido").html(listview.render().$el);

        //return this;
    },
	initialize: function(options) {
	      _.bindAll(this, 'render'); // every function that uses 'this' as the current object should be in here
		console.log(options);
		this.url = options.url;
		this.link = options.link;
		this.elemento = options.elemento;
    },
	goBack: function(e) {
		e.preventDefault();
		window.history.back()
    }
  });
  // Our module now returns our view
  return ListadoView;
});