define([
  'jquery',
  'underscore',
  'backbone',
  'vars',
  'text!tpl/listado/ItemView.html',
  'moment'
], function($, _, Backbone, vars, ItemViewTemp, moment){

  var ItemView = Backbone.View.extend({
    link : "",
    tagName: 'li',
    events: {
      'click': 'click'
    },
    initialize: function(options){
      _.bindAll(this, 'render'); // every function that uses 'this' as the current object should be in here
	  
	  this.link = options.link;
	  
    },
    render: function(){
		
		linkstr = this.link + this.model.get('id')
		if (typeof(this.model.get('rss')) != "undefined" ){
			linkstr = this.link + encodeURIComponent(this.model.get('rss'));
		}
		
		var data = {link: linkstr,
					imagen: this.model.get('imagen'),
					titulo: this.model.get('nombre'),
					icono: this.model.get('icon'),
					numero: this.model.get('numero'),
					direccion: this.model.get('direccion'),
					valido_hasta: this.model.get('valido_hasta'),
					gusta: this.model.get('log_gusta'),
					vistas: this.model.get('log_vistas'),
					nombre_empresa: this.model.get('nombre_comercio'),
					texto: this.model.get('texto'),
					ciudad_nombre: this.model.get('ciudad_nombre'),
					esarchivo: this.model.get('archivo'),
		};
		delete data.distancia;
		
		
		if (typeof(this.model.get('valido_hasta')) != "undefined")
		{
			//console.log(this.model.get('valido_hasta'));
			Aux = vars.parse_date(this.model.get('valido_hasta'))

			//console.log(Aux.toString('dd-MM-y'));
			data.valido_hasta = "Válido hasta " + Aux.getDate() + "/" + Aux.getMonth() + "/" + Aux.getFullYear();
			


			var d1 = new Date();
			var d2 = new Date(this.model.get('valido_hasta'));
			var diasfaltan = vars.DateDiff.inDays(d1, d2);

			if (diasfaltan < 5){
				if (diasfaltan > 1){
					data.valido_hasta = "Caduca en " + diasfaltan + " dias";
				}
				else if (diasfaltan == 1){
					data.valido_hasta = "Caduca en " + diasfaltan + " día";
				}
				
				data.resaltarfecha = true;
			}
			
			
		}
		else{
			if (typeof(this.model.get('fecha_inicio')) != "undefined"){
				console.log(this.model.get('fecha_inicio') + "  " + this.model.get('fecha_fin'));
				data.fechas = vars.formatoFechas(this.model.get('fecha_inicio'),this.model.get('fecha_fin'));
			}
	
		}

		
				
		if (typeof(this.model.get('latitud')) != "undefined" && typeof(this.model.get('longitud')) != "undefined" ){
			data.distancia = vars.Distancia(this.model.get('latitud'),this.model.get('longitud'));
		}
		

		
		var compiledTemplate = _.template( ItemViewTemp, data );

		this.$el.html(compiledTemplate);
		if (typeof(data.esarchivo) != "undefined" && data.esarchivo !== "1" ){
			this.$el.addClass("archivado");
		}
		
		this.$("img.no-img").hide();
		
		this.$("img:not(.no-img)").hide().on("load",function(){$(this).fadeIn()});
		this.$("img:not(.no-img)").hide().on("error",function(){$(this).parent().find("img.no-img").fadeIn();});
		

		//$(this.$el).html('<a href="'+this.link + this.model.get('id')+'"><img src="'+this.model.get('imagen')+'" /><span class="titulo">'+this.model.get('nombre')+'</span></a>');
		return this; // for chainable calls, like .render().el
    },	
  });

    // Our module now returns our view
  return ItemView;
});
