// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'models/ItemListado',
  'collections/ListaCollection',
  'views/listado/ItemView',
  'tinyscrollbar',
  'vars',
  'backbone_fetch_cache'
], function($, _, Backbone, Item, List, ItemView,tinyscrollbar, vars,backbone_fetch_cache){

  // Because the new features (swap and delete) are intrinsic to each `Item`, there is no need to modify `ListView`.
  var ListView = Backbone.View.extend({
   events: {
	   'click ul li a' : 'click'
    },
    initialize: function(options){
	
      _.bindAll(this, 'render', 'appendItem', "click"); // every function that uses 'this' as the current object should be in here
	  var self = this;
	  
	  if (typeof(options.cache) != "undefined"){
		  this.cache = options.cache;
	  }
	  else{
		  this.cache = vars.cacheActivo;
	  }

	  if (typeof(options.externo) != "undefined"){
		  this.externo = options.externo;
	  }

      this.collection = new List();
	  this.collection.url = url_datos + options.url;

	  this.link = options.link;
	  self.contador = 0;
	  self.total = 0;
	  
	  self.arrayLocalizacion = Array();
	  vars.arrayLocalizacion = Array();

      this.collection.bind('add', this.appendItem); // collection event binder
	  this.collection.fetch({prefill:this.cache, prefillSuccess:function(){},success: function(test){
			if (self.collection.length == 0){
				self.mostrarSinResultado();
			}
			else{
				self.contador = 0;
				self.total = self.collection.length;
				// Almacenamos todas las latitudes y lognitudes si las hay para generar el mapa con todos los puntos
				self.collection.each(function(model){
					latitud = model.get("latitud");
					longitud = model.get("longitud");
					
					if (typeof(latitud) != "undefined" && typeof(longitud) != "undefined" && latitud != "" && longitud != ""){
						self.arrayLocalizacion.push(Array(model.get("nombre"), latitud, longitud));
					}
					
				},this);
				
				if (self.arrayLocalizacion.length > 0){
					vars.arrayLocalizacion = self.arrayLocalizacion;
					self.$el.prepend('<a href="#mapa-grupo" class="ver_mapa"><span class="icono icon-localizacion"></span>Ver en mapa</a>');
				}
				
				// Boton mostrar archivados
				if (self.$el.find("li.archivado").length > 0){
					self.$el.find("li:not(.archivado):last").after('<a href="" class="verarchivados">Ver archivados</a>');
					
					self.$el.find("a.verarchivados").on("click",function(e){
						self.$el.find("li.archivado").show();
						e.preventDefault();
					});
				}


				
				
						
			}
		},error: function(collection, response, options){
			if (vars.online == false){
				self.$el.find("div.loading").hide();
				self.$el.append('<p class="no_results">Necesitas estar conectado a internet para obtener los datos.</p>');
			}
		}
		});
	  
  
    },
    render: function(){
		this.$el.html('<div class="loading"></div><ul></ul>');

      return this;
    },
    appendItem: function(item){
	  if (this.contador == this.total){
		  this.$el.find("div.loading").hide();
		  this.$el.find("ul").hide().fadeIn("fast");
	  }
	  else if (this.contador > this.total || this.total == 0){
		  this.$el.find("div.loading").hide();
		  this.$el.find("ul").show();
		  
	  }

      var itemView = new ItemView({
        model: item,
		link: this.link
      });
      $('ul', this.$el).append(itemView.render().$el);
	  
	  self.$('p.no_results').hide();
	  
	  this.contador++;
	  
    },
	click: function(event){
		if (!this.externo){
			vars.putSeccion($(event.currentTarget).find("span.titulo").html());
		}
		else{ 
			window.open(decodeURIComponent($(event.currentTarget).attr("href")),'_system','location=yes');
		}
	},
	mostrarSinResultado: function(){
		this.$el.find("div.loading").hide();
		this.$el.append('<p class="no_results">Sin resultados</p>');
	}
  });


    // Our module now returns our view
  return ListView;
});
