// Filename: views/project/list
define([
  'jquery',
  'underscore',
  'backbone',
  'views/listado/ListView',
  'text!tpl/listado/ListadoView.html',
  'vars'
], function($, _, Backbone, ListView, ListadoViewTemp, vars){


  ListadoView = Backbone.View.extend({
    url : "",
    link : "",
    titulo : "Titulo",
    css : "",
    noback : false,
	events: {
	  'click a.back-button': 'goBack'
	},
    render: function(){
		// Using Underscore we can compile our template with data
		var self = this;
		var data = {titulo: this.titulo, css: this.css,noback: this.noback};
		var compiledTemplate = _.template( ListadoViewTemp, data );

		this.$el.html(compiledTemplate);

		var listview = new ListView({url:this.url  , link: this.link, externo: this.externo});
		this.$el.find("div.listado").html(listview.render().$el);

		delete temporalciudad;

        return this;
    },
	initialize: function(options) {
	    _.bindAll(this, 'render'); // every function that uses 'this' as the current object should be in here

		this.url = options.url;
		this.link = options.link;
		this.titulo = options.titulo;
		this.css = options.css;
		
		if (typeof(options.noback) != "undefined")
			this.noback = options.noback;
			
		this.externo = false;
		if (typeof(options.externo) != "undefined")
			this.externo = options.externo;
		
    },
	goBack: function(e) {
		e.preventDefault();
		vars.goBack();
    }
  });
  // Our module now returns our view
  return ListadoView;
});